import { httpApi } from "api/http.api";
import { IAssignUnassign } from "interfaces/APIInterface/IAssignTo";
import { readUserId } from "./localStorage.service";

export const getUserGroupList = (orderId: string | undefined) => {
  return httpApi
    .get("/order/getunassociatedusergrouplist" + "/" + orderId)
    .then((response) => response)
    .catch((error) => {
      throw error;
    });
};

export const getUsersInUserGroupList = (orderId: string | undefined) => {
  return httpApi
    .get("/order/getusersinusergroup" + "/" + orderId)
    .then((response) => response)
    .catch((error) => {
      throw error;
    });
};

export const AssignOwnerAndUserGroup = (AssignUnassignPayload: IAssignUnassign) => {
  return httpApi
    .post("/order/assignownerandusergroup", AssignUnassignPayload)
    .then((response) => response)
    .catch((error) => {
      throw error;
    });
};

export const getUsersInMyTeam = () => {
  return httpApi
    .get("/order/getusersinmyteam" + "/" + readUserId())
    .then((response) => response)
    .catch((error) => {
      throw error;
    });
};
