/* eslint-disable max-len */
import { httpApi } from "api/http.api";
import { persistGlobalSetting } from "./localStorage.service";

export const getGeneralGlobalSetting = async () => {
  return httpApi
    .get("/generalsetting/list")
    .then(async (res) => {
      const timeZoneList = res?.data?.GeneralSetting?.TimeZoneList;
      // eslint-disable-next-line @typescript-eslint/no-explicit-any
      const timeZoneData = timeZoneList?.find((item: any) => {
        return item?.IsDefault === true;
      });

      const dateFormatList = res?.data?.GeneralSetting?.DateFormatList;
      // eslint-disable-next-line @typescript-eslint/no-explicit-any
      const dateFormatData = dateFormatList?.find((item: any) => {
        return item?.IsDefault === true;
      });

      const timeFormatList = res?.data?.GeneralSetting?.TimeFormatList;
      // eslint-disable-next-line @typescript-eslint/no-explicit-any
      const timeFormatData = timeFormatList?.find((item: any) => {
        return item?.IsDefault === true;
      });

      const priceRoundOffList = res?.data?.GeneralSetting?.PriceRoundOffList;
      // eslint-disable-next-line @typescript-eslint/no-explicit-any
      const priceRoundOffData = priceRoundOffList[0];

      const globalSetting = {
        DisplayTimeZone: timeZoneData?.TimeZoneDetailsDesc,
        ServerTimeZone: res?.data?.GeneralSetting?.ServerTimeZone,
        DateFormat: dateFormatData?.DateFormat,
        TimeFormat: timeFormatData?.TimeFormat,
        PriceRoundOff: priceRoundOffData?.FeatureValues,
      };

      //To store the time zone settings in the local storage.
      await persistGlobalSetting(globalSetting);
    })
    .catch((error) => {
      throw error;
    });
};
