/* eslint-disable max-len */
import { httpApi } from "api/http.api";
import {
  CREATE_ORDER_NOTE_API,
  DELET_ORDERNOTE_API,
  GET_ORDERNOTEFILTERS,
  ORDERLOG_LIST_URL,
  ORDER_NOTE_EXPORT,
  UPDATE_ORDERNOTE_API,
} from "config/constant";
import {
  IExportParams,
  IOrderNoteUpdateParams,
  IOrderNotesParams,
} from "interfaces/APIInterface/IOrderNote";

export const createNote = (createNotePayload: IOrderNotesParams) => {
  return httpApi
    .post(CREATE_ORDER_NOTE_API, createNotePayload)
    .then((response) => response.data)
    .catch((error) => {
      throw error;
    });
};
export const getOrderNote = (getNotePayload: IOrderNotesParams) => {
  return httpApi
    .post(ORDERLOG_LIST_URL, getNotePayload)
    .then((response) => response.data)
    .catch((error) => {
      throw error;
    });
};
export const deleteOrderNote = (deleteNotebody: IOrderNotesParams) => {
  return httpApi
    .post(DELET_ORDERNOTE_API, deleteNotebody)
    .then((response) => response.data)
    .catch((error) => {
      throw error;
    });
};
export const updateOrderNote = (createNotePayload: IOrderNoteUpdateParams) => {
  return httpApi
    .post(UPDATE_ORDERNOTE_API, createNotePayload)
    .then((response) => response.data)
    .catch((error) => {
      throw error;
    });
};
export const getExportOrderNote = (exportBody: IExportParams) => {
  const fileUrl = document.createElement("a");
  fileUrl.href = ORDER_NOTE_EXPORT + "/" + exportBody.OrderId + "/" + exportBody.FileType+"/"+exportBody.ViewFilter;
  fileUrl.click();
};
export const getOrderNoteFilters = (getFilterPayload: { OrderId: string }) => {
  return httpApi
    .get(GET_ORDERNOTEFILTERS + "/" + getFilterPayload.OrderId)
    .then((response) => response.data)
    .catch((error) => {
      throw error;
    });
};
