import { httpApi } from "api/http.api";
import { GET_SHIPPING_METHODS_API } from "config/constant";
import { IShippingMethod } from "interfaces/APIInterface/IShipping";

/**
 * This function is used to get shipping methods by passing shippingMethodPayload
 * to API and return the required response from it.
 * @param shippingMethodPayload contains properties of IShippingMethod interface.
 * @returns response from GET_SHIPPING_METHODS_API.
 */
export const getShippingMethod = (PostalCode: string, shippingMethodPayload: IShippingMethod) => {
  return httpApi
    .post(GET_SHIPPING_METHODS_API + "/" + PostalCode, shippingMethodPayload)
    .then((response) => {
      return response;
    })
    .catch((error) => {
      throw error;
    });
};
