import { httpApi } from "api/http.api";

import {
  ICpRoleUserListParams,
  IManagerDelegateParams,
  IProfileChangePassword,
  ISavedDelegateParams,
  IUpdateProfileParams,
} from "interfaces/ClientInterface/IUserProfile";

export const updateUserProfile = (updateProfile: IUpdateProfileParams) => {
  return httpApi
    .put("/customeraccount/update", updateProfile)
    .then((response) => response.data)
    .catch((error) => {
      throw error;
    });
};
export const getUserProfileList = (userId: number | string) => {
  return httpApi
    .get("/users/getcustomeraccountdetails" + "/" + userId)
    .then((response) => response)
    .catch((error) => {
      throw error;
    });
};
export const getMangerDelegateList = (getManagerDelegatePayload: IManagerDelegateParams) => {
  return httpApi
    .get(
      "/globalattributeentity/getentityattributedetails" +
        "/" +
        getManagerDelegatePayload.entityId +
        "/" +
        getManagerDelegatePayload.entityType
    )
    .then((response) => response)
    .catch((error) => {
      throw error;
    });
};
export const saveCpRoleUsersDelegate = (saveCpUserProfileDelegate: ISavedDelegateParams) => {
  return httpApi
    .post("/userprofile/saveddelegate", saveCpUserProfileDelegate, {})
    .then((response) => response)
    .catch((error) => {
      throw error;
    });
};
export const getCpRoleUsers = (getCpRoleUserPayload: ICpRoleUserListParams) => {
  return httpApi
    .get("/userprofile/getcproleuserlist", {
      params: {
        userId: getCpRoleUserPayload.userId,
        userName: getCpRoleUserPayload.userName,
        roleName: getCpRoleUserPayload.roleName,
      },
    })
    .then((response) => response)
    .catch((error) => {
      throw error;
    });
};
export const changeUserPassword = (changePasswordPayload: IProfileChangePassword) => {
  return httpApi
    .post("/users/changepassword", changePasswordPayload, {})
    .then((response) => response)
    .catch((error) => {
      throw error;
    });
};
