/* eslint-disable no-unused-vars */
/* eslint-disable no-console */
/* eslint-disable max-len */
/* eslint-disable max-lines */
/* eslint-disable max-lines-per-function */
/* eslint-disable max-lines */
import React, { useEffect, useState } from "react";
import AddProductsHeader from "./AddProductsHeader";
import AddProductFilter from "./AddProductFilter";
import { Button, Card, Col, Row, Space, Typography } from "antd";
import { SaveOutlined, CheckCircleFilled } from "@ant-design/icons";
import ProductListTable from "./ProductsList";
import ProductDetail from "components/Common/Product/ProductDetail";
const { Text, Title } = Typography;
import "./AddProducts.scss";
import {
  ICategory,
  ICustomAttribute,
  IDictionary,
  IOrderProductCatalogProfile,
  IProduct,
  IProductDetailsProp,
  IProductFacet,
  IProductFacetAttributeValue,
  ISearchRequest,
} from "interfaces/APIInterface/IProducts";
import { TOP_PLACEMENT } from "config/constant";
import { notificationController } from "components/Common/Notification/Notification";
import {
  getCategoryList,
  getOrderProductCatalogProfileDetails,
  getProductDetails,
  getProductList,
} from "api/services/addProduct.api";
import { useNavigate, useParams } from "react-router-dom";
import { getPriceWithCurrency } from "utils";
import {
  IConfigurableProductRequestModel,
  //IConfigurableProductVarientNAModel,
  //`IConfigurableProductVarientNAModel`,
  ISelectInputOption,
  ISelectedVariant,
} from "interfaces/ClientInterface/IProducts";
import { ROUTES_PATH } from "routes/Routes.Constant";
import { IOrder } from "interfaces/ClientInterface/IEditOrder";
import { getOrder } from "api/services/editOrder.api";
import {
  DEFAULT_PRODUCT_QUANTITY,
  GET_ORDER_DETAILS_FAILED,
  getConfigurableAttributeValues,
  getAttributeValueForVariants,
} from "components/Common/Product/Product.Constant";
import { translate } from "i18n";
import { getGlobalSetting } from "api/services/localStorage.service";

const AddProducts = () => {
  const [product, setProduct] = useState({} as IProductDetailsProp);
  const [facets, setProductFacets] = useState({} as IProductFacet[]);
  const [productListData, setProducts] = useState<IProduct[]>([]);
  const [categoryListData, setCategories] = useState<ISelectInputOption[]>([]);
  const [selectedCategory, setCategory] = useState({} as ICategory);
  const { orderId } = useParams<Record<string, string | undefined>>();
  const [isProductAdded, setIsProductAdded] = useState({} as boolean);
  const [order, setOrder] = useState({} as IOrder);
  const [quantity, setQuantity] = useState({} as number | null);
  const [productNote, setProductNote] = useState<string>("");
  const [searchKeyword, setSearchKeyword] = useState<string | null>(null);
  const [selectedVariant, setSelectedVariant] = useState({} as ISelectedVariant);

  const navigate = useNavigate();
  // const [NA, setInputValue] = useState('');
  const [orderProductCatalogProfileData, setOrderProductCatalogProfileData] = useState(
    {} as IOrderProductCatalogProfile
  );
  const [configurableProductModel, setConfigurableProductModel] = useState(
    {} as IConfigurableProductRequestModel
  );
  const [totalProductCount, setTotalProductCount] = useState({} as number);
  const [currentPage, setCurrentPage] = useState(1 as number);
  const [currentPageSize, setCurrentPageSize] = useState(10 as number);
  const [sortingColumn, setSortingColumn] = useState({
    sortByColumnName: "",
    sortType: "",
  });
  const [sortingColumnForProductFilter, setSortingColumnForProductFilter] = useState({
    sortByColumnNameFilter: "",
    sortTypeFilter: "",
  });
  const [editQuantity, setEditQuantity] = useState({} as number | null);
  const globalSettings = getGlobalSetting() ? JSON.parse(getGlobalSetting() || "") : {};
  const priceRoundOff = globalSettings?.PriceRoundOff;
  const [variant, setVariant] = useState<string[]>([]);
  const [isProductFilter, setIsProductFilter] = useState(false as boolean);
  const [selectCustomAttribute ,setCustomatrribute] = useState<ICustomAttribute[]>([]);
  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  const [showStock,setshowStock]=useState(false);
  const [ParentProductImage, setParentProductImage] = useState<string>("");
  // eslint-disable-next-line @typescript-eslint/no-unused-vars
 
  useEffect(() => {
    getOrderDetailsAndProductList();
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, []);

  useEffect(() => {
    if (searchKeyword?.length == 0) {
      getOrderDetailsAndProductList();
    }
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [searchKeyword]);

  /**
   * This function gets called on the Update Filter button click and
   * fetch the product list again with the updated filters.
   */
  const getOrderDetailsAndProductList = async () => {
    const orderData: IOrder = await getOrderDetails(orderId);
    const orderProductCatalogProfileDetails: IOrderProductCatalogProfile =
      await fetchOrderProductCatalogProfileDetails(orderData?.UserId, orderData?.PortalId);
    fetchProductList(
      selectedCategory,
      orderData,
      orderProductCatalogProfileDetails,
      currentPage,
      currentPageSize,
      sortingColumn.sortByColumnName,
      sortingColumn.sortType
    );
    fetchCategoryList(orderData, orderProductCatalogProfileDetails?.CatalogId);
  };

  /**
   * This function gets called on the Update Filter button click and
   * fetch the product list again with the updated filters.
   */
  const onFilterApplied = (clearProductFilter? : boolean | false) => {
    setCurrentPage(1);
    fetchProductList(
      selectedCategory,
      order,
      orderProductCatalogProfileData,
      1,
      currentPageSize,
      sortingColumnForProductFilter.sortByColumnNameFilter,
      sortingColumnForProductFilter.sortTypeFilter,
      clearProductFilter
    );
  };

  /**
   * This function sets the RefineBy property so that the updated value be sent in the request to
   * fetch the product list.
   */
  const setRefineByFilter = (refineBy: IDictionary<string[]>) => {
    if (facets != null && facets != undefined && facets.length != undefined) {
      {
        facets &&
          facets.forEach((facetRecord: IProductFacet) => {
            if (facetRecord.AttributeValues) {
              const attributeLabels: string[] = [];

              facetRecord.AttributeValues.forEach(
                (facetAttributeValue: IProductFacetAttributeValue) => {
                  if (facetAttributeValue && facetAttributeValue.IsChecked) {
                    attributeLabels.push(facetAttributeValue.Label);
                  }
                }
              );

              if (attributeLabels.length > 0) {
                refineBy[facetRecord.AttributeCode] = attributeLabels;
              }
            }
          });
      }
    }
  };

  /**
   * This function sets the ISearchRequest model which gets sent in the request to
   * fetch the product list.
   */
  const setSearchRequestModel = (
    refineBy: IDictionary<string[]>,
    selectedCategory: ICategory,
    orderData: IOrder,
    orderProductCatalogProfileDetails: IOrderProductCatalogProfile,
    pageNumber: number,
    pageSize: number,
    columnName: string,
    orderType: string
  ) => {
    const searchRequest: ISearchRequest = {
      CatalogId: orderProductCatalogProfileDetails?.CatalogId,
      Category: selectedCategory.Name,
      CategoryId: selectedCategory.PublishCategoryId,
      IsFacetList: true,
      LocaleId: orderData?.LocaleId,
      PageNumber: pageNumber,
      PageSize: pageSize,
      PortalId: orderData?.PortalId,
      ProfileId: orderProductCatalogProfileDetails?.ProfileId,
      UseSuggestion: true,
      RefineBy: refineBy,
      Keyword: searchKeyword,
      ColumnName: columnName,
      OrderType: orderType,
    };

    return searchRequest;
  };

  /**
   * This function gets called on the pagination button click and
   * fetch the product list again with the updated filters.
   */
  const onPaginationChange = (page: number, pageSize: number) => {
    fetchProductList(
      selectedCategory,
      order,
      orderProductCatalogProfileData,
      page,
      pageSize,
      sortingColumn.sortByColumnName,
      sortingColumn.sortType
    );
  };

  const handleSort = (columnName: string, orderType: string) => {
    fetchProductList(
      selectedCategory,
      order,
      orderProductCatalogProfileData,
      currentPage,
      currentPageSize,
      columnName,
      orderType
    );
  };

  /**
   * This function is used to get the list of products by sending ISearchRequest as a parameter
   */
  const fetchProductList = (
    selectedCategory: ICategory,
    orderData: IOrder,
    orderProductCatalogProfileDetails: IOrderProductCatalogProfile,
    pageNumber: number,
    pageSize: number,
    columnName: string,
    orderType: string,
    clearProductFilter?: boolean | false,
  ) => {
    const refineBy: IDictionary<string[]> = {};

    if(!clearProductFilter)
      setRefineByFilter(refineBy);

    const searchRequest: ISearchRequest = setSearchRequestModel(
      refineBy,
      selectedCategory,
      orderData,
      orderProductCatalogProfileDetails,
      pageNumber,
      pageSize,
      columnName,
      orderType
    );

    getProductList(searchRequest)
      .then((response) => {
        const productDataList: IProduct[] = response.Search?.Products;
        productDataList &&
          productDataList.forEach((product) => {
            const Price = product.SalesPrice == null ? product?.RetailPrice : product?.SalesPrice;
            const productPrice =
              typeof Price === "number" ? parseFloat(Price).toFixed(priceRoundOff) : Price;
            product.Price = getPriceWithCurrency(product.CurrencySuffix, productPrice);
          });
        setProducts(productDataList);
        setTotalProductCount(response.Search?.TotalProductCount);

        if (Object.keys(refineBy).length <= 0 || clearProductFilter) {
          const productFacetList: IProductFacet[] = response.Search?.Facets;
          setProductFacets(productFacetList);
          setIsProductFilter(false);
        }
        else{          
          setIsProductFilter(true);
        }
      })
      .catch((err) => {
        notificationController.error({ message: err.message, placement: TOP_PLACEMENT });
      });
  };

  /**
   * This function is used to get the list of categories for the catalogId.
   */
  const fetchCategoryList = (orderData: IOrder, catalogId: number) => {
    getCategoryList(catalogId, orderData?.LocaleId, orderData?.PortalId)
      .then((response) => {
        const categories: ICategory[] = response.Categories;
        const categoryList: ISelectInputOption[] = [];

        categories &&
          categories.forEach((categoryRecord: ICategory) => {
            const categoryItem: ISelectInputOption = {
              value: `${categoryRecord.PublishCategoryId}`,
              label: categoryRecord.Name,
            };
            categoryList.push(categoryItem);
          });

        setCategories(categoryList);
      })
      .catch((error) => {
        notificationController.error({ message: error.message, placement: TOP_PLACEMENT });
      });
  };

  /**
   * This function gets called on the product click from the product list and
   * get the clicked product details.
   */
  const onProductClick = (row: IProduct) => {
    //below 2 lines are used to scroll the window to the top
    const scrollDiv = document.getElementById("products");
    scrollDiv?.scrollIntoView({ behavior: "smooth" });
    if (row.ZnodeProductId) {
      getProductDetails(
        row.ZnodeProductId,
        orderProductCatalogProfileData?.CatalogId,
        order?.LocaleId,
        order?.PortalId
      )
        .then((response) => {
          setIsProductAdded(false);
          const productDetails: IProductDetailsProp = response.PublishProduct;
          productDetails.VersionId = row.VersionId;
          setParentProductImage(productDetails.ParentProductImageSmallPath);
          const Price =
            productDetails.SalesPrice == null
              ? productDetails?.RetailPrice
              : productDetails?.SalesPrice;
          const productPrice = typeof Price === "number" ? Price?.toFixed(priceRoundOff) : Price;

          const formattedPriceTiers =
            productDetails && productDetails?.TierPriceList?.length > 0
              ? productDetails?.TierPriceList?.map((tier) => ({
                ...tier,
                Price:
                    typeof tier.Price === "number"
                      ? parseFloat(tier?.Price).toFixed(priceRoundOff)
                      : tier?.Price,
              }))
              : [];

          setProduct({
            ...productDetails,
            Price: productPrice,
            TierPriceList: formattedPriceTiers,
          });
          setQuantity(DEFAULT_PRODUCT_QUANTITY);
          setProductNote("");
         
          const attributeCodeVariant: string[] = getConfigurableAttributeValues(
           
            productDetails.Attributes
            
          );     
          
          // eslint-disable-next-line no-unused-vars
          // const filterOpenFlags = productDetails.Attributes?.filter((item) => {
          //   attributeCodeVariant.forEach(element => {
          //     if (item.AttributeCode ==  element) {
          //       item.ConfigurableAttribute.unshift(initialNA); 
          //     }
          //   });
           
          // });
          setVariant(attributeCodeVariant);
          const DefaultSelectedVariant: string[] = getAttributeValueForVariants(
            productDetails.Attributes,
            attributeCodeVariant
          );

          setSelectedVariant({
            defaultVariant: DefaultSelectedVariant,
          });
          
          setConfigurableProductDetailsModel(
            row.ZnodeProductId,
            row.SKU,
            productDetails.ConfigurableProductSKU,
            productDetails.ParentConfiguarableProductName
          );        
        })        
        .catch((err) => {
          notificationController.error({ message: err.message, placement: TOP_PLACEMENT });
        });
    }
  };

  /**
   * This function is used to navigate to the edit order page.
   */
  const backToEditOrder = () => {
    navigate(`/${ROUTES_PATH.EDIT_ORDER}/${orderId}`);
  };

  /**
   * This function is used to get the order summary details.
   */
  const getOrderDetails = async (orderId: string | undefined) => {
    return await getOrder(orderId)
      .then((response) => {
        const orderData: IOrder = response?.Order;
        setOrder(orderData);
        return response?.Order;
      })
      .catch(() => {
        notificationController.error({ message: GET_ORDER_DETAILS_FAILED });
      });
  };
  /**
   * This function is used to get the order product catalog and user profile details
   */
  const fetchOrderProductCatalogProfileDetails = async (userId: number, portalId: number) => {
    return await getOrderProductCatalogProfileDetails(userId, portalId)
      .then((response) => {
        const orderProductCatalogProfileDetails: IOrderProductCatalogProfile =
          response?.OrderProductCatalogProfile;

        setOrderProductCatalogProfileData(orderProductCatalogProfileDetails);

        return response?.OrderProductCatalogProfile;
      })
      .catch(() => {
        notificationController.error({ message: GET_ORDER_DETAILS_FAILED });
      });
  };
  /**
   * This function is used to set the ConfigurableProductModel which will be passed to API
   * to get the configurable product details
   */
  const setConfigurableProductDetailsModel = (
    parentProductId: number,
    parentProductSKU: string,
    childSku: string,
    parentConfiguarableProductName :string
  ) => {
    const configurableProductModelDetails: IConfigurableProductRequestModel = {
      localeId: order?.LocaleId,
      parentProductId: parentProductId,
      parentProductSKU: parentProductSKU,
      portalId: order?.PortalId,
      publishCatalogId: orderProductCatalogProfileData?.CatalogId,
      sku: childSku,
      ParentProductName :parentConfiguarableProductName
    };
    setConfigurableProductModel(configurableProductModelDetails);
  };
 

 
  
  return (

    <>
      <div className="scroll-product-container" id="products" />
      
      
      {/* //<button onClick={initialNA}>Add NA Textbox</button> */}
    
      <Space direction="vertical" size={"middle"} className="d-flex mt-16">
        <AddProductsHeader orderSummary={order} />
        <Row gutter={[16, 16]} className="add-product-container">
          <Col span={12} xs={24} sm={24} md={24} lg={12} xl={12}>
            <Card className="card-container filter">
              <Space className="product-filter-container d-flex" direction="vertical" size={20}>
                <AddProductFilter
                  facets={facets}
                  categoryListData={categoryListData}
                  searchKeyword={searchKeyword}
                  order={order}
                  orderProductCatalogProfileData={orderProductCatalogProfileData}
                  setProductFacets={setProductFacets}
                  setCategory={setCategory}
                  onFilterApplied={onFilterApplied}
                  fetchProductList={fetchProductList}
                  setSearchKeyword={setSearchKeyword}
                  currentPageSize={currentPageSize}
                  sortingColumnForProductFilter={sortingColumnForProductFilter}
                  setSortingColumnForProductFilter={setSortingColumnForProductFilter}
                  handleSort={handleSort}
                  setCurrentPage={setCurrentPage}
                  isProductFilter={isProductFilter}
                />
                <ProductListTable
                  productListData={productListData}
                  onProductClick={onProductClick}
                  totalProductCount={totalProductCount}
                  currentPage={currentPage}
                  setCurrentPage={setCurrentPage}
                  currentPageSize={currentPageSize}
                  setCurrentPageSize={setCurrentPageSize}
                  onPaginationChange={onPaginationChange}
                  sortingColumn={sortingColumn}
                  setSortingColumn={setSortingColumn}
                  handleSort={handleSort}
                />
              </Space>
            </Card>
          </Col>
          <Col span={12} xs={24} sm={24} md={24} lg={12} xl={12}>
            <Card className="card-container">
              {Object.keys(product).length === 0 ? (
                <Space direction="vertical" size={1} className="empty-table-container-add-product">
                  <Button
                    type="primary"
                    shape="circle"
                    icon={<SaveOutlined />}
                    size={"large"}
                    data-test-selector="btnAddProduct"
                    className="pointer-none"
                  />
                  <Title level={4}>{translate("addProduct.selectProductTitle")}</Title>
                  <Text className="m-0">
                    {translate("addProduct.selectProductInformationMessage")}
                  </Text>
                </Space>
              ) : isProductAdded === true ? (
                <Space direction="vertical" size={1} className="empty-table-container-add-product">
                  <Button
                    type="primary"
                    shape="circle"
                    icon={<CheckCircleFilled />}
                    size={"large"}
                    data-test-selector="btnAddProduct"
                    className="product-added-done pointer-none"
                  />
                  <Title level={4}>{translate("addProduct.productAddedToOrderTitle")}</Title>
                  <Text className="m-0">
                    {translate("addProduct.continueOrderOrGobackMessage")}{" "}
                    <a onClick={backToEditOrder}>
                      {translate("addProduct.backToOrderDetailsLink")}
                    </a>
                    .
                  </Text>
                </Space>
              ) : (
                <ProductDetail
                  product={product}
                  orderId={orderId}
                  quantity={quantity}
                  productNote={productNote}
                  selectedVariant={selectedVariant}
                  configurableProductModel={configurableProductModel}
                  setProduct={setProduct}
                  setIsProductAdded={setIsProductAdded}
                  setQuantity={setQuantity}
                  setProductNote={setProductNote}
                  setSelectedVariant={setSelectedVariant}
                  editQuantity={editQuantity}
                  setEditQuantity={setEditQuantity}
                  variant={variant}
                  selectCustomAttribute={selectCustomAttribute}
                  setCustomatrribute={setCustomatrribute}
                  setshowStock={setshowStock} 
                  showStock={showStock}
                  ParentProductImage={ParentProductImage} />
              )}
            </Card>
          </Col>
        </Row>
      </Space>
    </>
  );
};

export default AddProducts;
