import React from "react";
import { Card, Row, Col, theme } from "antd";
import { IMetricsProps } from "interfaces/APIInterface/IMetrics";
import { translate } from "i18n";
import "../../Dashboard/Dashboard.scss";

const { useToken } = theme;

//Added the props to consume metrics details in the dashboard.
const Metrics: React.FC<IMetricsProps> = ({
  TotalOrder,
  TotalQuote,
  TotalReturn,
  TotalSale,
}: IMetricsProps) => {
  const { token } = useToken();
  return (
    <Card title="Metrics">
      <Row gutter={16}>
        <Col className="gutter-row" span={12}>
          <div className="grid-box" style={{ backgroundColor: token.colorPrimary }}>
            <label className="box-label">{translate("dashboard.metricsBoxTitle")}</label>
            <h4 className="count-value">{TotalOrder}</h4>
          </div>
        </Col>
        <Col className="gutter-row" span={12}>
          <div className="grid-box" style={{ backgroundColor: token.colorPrimary }}>
            <label className="box-label">{translate("dashboard.metricsTotalOpenOrders")}</label>
            <h4 className="count-value">{TotalQuote}</h4>
          </div>
        </Col>
      </Row>
      <Row gutter={16}>
        <Col className="gutter-row" span={12}>
          <div className="grid-box" style={{ backgroundColor: token.colorPrimary }}>
            <label className="box-label">{translate("dashboard.metricsMyGroupsOrders")}</label>
            <h4 className="count-value">{TotalReturn}</h4>
          </div>
        </Col>
        <Col className="gutter-row" span={12}>
          <div className="grid-box" style={{ backgroundColor: token.colorPrimary }}>
            <label className="box-label">{translate("dashboard.metricsMetricName")}</label>
            <h4 className="count-value">{TotalSale}</h4>
          </div>
        </Col>
      </Row>
    </Card>
  );
};

export default Metrics;
