import React from "react";
import { Space } from "antd";
import { LockTwoTone } from "@ant-design/icons";

import "./NoAccess.scss";
import { translate } from "i18n";

interface NoAccessPage {
  message?: string | React.ReactNode;
}

export const NoAccessPage: React.FC<NoAccessPage> = ({ message }: NoAccessPage) => {
  return (
    <Space className="no-access-container" align="center" direction="vertical">
      <LockTwoTone className="lock-icon" />
      <div>{message ? message : translate("common.noAccessPermissionMessage")}</div>
    </Space>
  );
};

export default NoAccessPage;
