/* eslint-disable prefer-const */
/* eslint-disable react-hooks/rules-of-hooks */
/* eslint-disable no-empty */
/* eslint-disable max-lines-per-function */
/* eslint-disable no-unused-vars */
/* eslint-disable max-len */
import React, { useState } from "react";
import { Col, Row, Space, Typography } from "antd";
import {
  IConfigurableProductModel,
  ICustomAttribute,
  IDictionary,
  IProductDetailsProp,
} from "interfaces/APIInterface/IProducts";
import { IConfigurableAttributeProp, ISelectedVariant } from "interfaces/ClientInterface/IProducts";
import { APPAREL_SIZE, COLOR,  THUMBNAIL_IMAGE_PATH,  TOP_PLACEMENT, Znode_NA_Code } from "config/constant";
import { getConfigurableProductDetails } from "api/services/addProduct.api";
import { notificationController } from "components/Common/Notification/Notification";
import { translate } from "i18n";
import { getGlobalSetting } from "api/services/localStorage.service";
import { CheckConfiguarableNAAttribute, NAConfigurableAttributePrice } from "../Product.Constant";



const { Text } = Typography;
// eslint-disable-next-line max-lines-per-function
const VariantSelection: React.FC<IConfigurableAttributeProp> = ({
  configurableAttributes,
  setProduct,
  selectedVariant,
  setSelectedVariant,
  configurableProductModel,
  variant,
  index,
  selectCustomAttribute,
  setCustomatrribute,
  setshowStock,
  ParentProductImage
  
}: IConfigurableAttributeProp) => {

  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  // const [showStock,setshowStock]=useState(false);

  /**
   * This function gets called on the product size variant selection and
   * sets the selected variant details and gets the configurable product details
   */
  let customattirbutesData: ICustomAttribute[] = [];
  const variantSelectHandler = (attributeValue: string) => {
    const globalSettings = getGlobalSetting() ? JSON.parse(getGlobalSetting() || "") : {};
    const priceRoundOff = globalSettings?.PriceRoundOff;
    //const [selectAttributeValue, setSelectAttributeValue] = useState("");
    setSelectedVariant((prevState: ISelectedVariant) => ({
      ...prevState,
      defaultVariant: {
        ...prevState.defaultVariant,
        [index]: attributeValue,
      },
    }));
    
   
    const selectedAttributes: IDictionary<string> = {};
    selectedAttributes[variant[index]] = attributeValue;
    if (variant && variant?.length > 0) {
      variant = [...variant].sort((a, b) => a.localeCompare(b));
      variant?.forEach((item, key) => {
        if (index !== key) {
          customattirbutesData = NAConfigurableProduct(attributeValue, selectCustomAttribute, variant, index, customattirbutesData, setCustomatrribute);


          selectedAttributes[item] = selectedVariant?.defaultVariant[key];    
          const attributeCode = customattirbutesData?.find((x) => x.AttributeCode == variant[key]);
          if(attributeCode==null){
            const customattirbute: ICustomAttribute = {
              AttributeCode: variant[key],
              AttributeValues: selectedAttributes[variant[key]],
            };        
            customattirbutesData.push(customattirbute);  
            setCustomatrribute(customattirbutesData); 
          }   
        }
      }); 
      if (attributeValue === Znode_NA_Code) {      
        // Check if ParentProductImage is not null or undefined
        if (ParentProductImage != null) {
          const customattirbute: ICustomAttribute = {
            AttributeCode: "ProductImage",
            AttributeValues: ParentProductImage,
          }; 
          // Check if customattirbutesData already contains the product image
          const isProductImageExist = customattirbutesData.some(attribute => attribute.AttributeCode === "ProductImage");
          if (!isProductImageExist) {
            customattirbutesData.push(customattirbute);     
            setCustomatrribute(customattirbutesData); 
          }
        }
      }
    }
     
    const productAttributes: IConfigurableProductModel = {
      Codes: variant?.join(","),
      IsProductEdit: false,
      IsQuickView: false,
      IsQuote: false,
      LocaleId: configurableProductModel?.localeId,
      ParentOmsSavedCartLineItemId: null,
      ParentProductId: configurableProductModel?.parentProductId,
      ParentProductSKU: configurableProductModel?.parentProductSKU,
      PortalId: configurableProductModel?.portalId,
      PublishCatalogId: configurableProductModel?.publishCatalogId,
      Sku:
        attributeValue != Znode_NA_Code
          ? configurableProductModel?.sku
          : configurableProductModel?.parentProductSKU,
      SelectedAttributes: selectedAttributes,
      SelectedCode: variant[index],
      SelectedValue: attributeValue,
      Values: `${selectedVariant?.defaultVariant[index]},${attributeValue}`,
      IsNAAttributeAvailable:false,
    };

    /**
     * This function is used to get the specific configurable product details
     */
    getConfigurableProductDetails(productAttributes)
      .then((response) => {
        const productDetails: IProductDetailsProp = response?.PublishProduct;

        const Price =
          productDetails.SalesPrice == null
            ? productDetails?.RetailPrice
            : productDetails?.SalesPrice;
        let productPrice = typeof Price === "number" ? Price?.toFixed(priceRoundOff) : Price;       
        
        const NAConfigurableData =  NAConfigurableAttributePrice(customattirbutesData, productPrice);
        const isProductNa =NAConfigurableData.isProductNa;
        productPrice=NAConfigurableData.productPrice;
        setshowStock(isProductNa);
        const formattedPriceTiers =
          productDetails && productDetails?.TierPriceList?.length > 0
            ? productDetails?.TierPriceList?.map((tier) => ({
              ...tier,
              Price:
                  typeof tier.Price === "number"
                    ? parseFloat(tier?.Price).toFixed(priceRoundOff)
                    : tier?.Price,
            }))
            : [];
        
        setProduct((prevState: IProductDetailsProp) => ({
          ...prevState,
          Name:  !isProductNa ? productDetails.Name : configurableProductModel.ParentProductName,
          OriginalImagePath: productDetails.OriginalImagepath,
          ImageThumbNailPath: !isProductNa ? productDetails.ImageThumbNailPath: THUMBNAIL_IMAGE_PATH+ ParentProductImage,
          SKU: productDetails.SKU,
          Quantity: productDetails.Quantity,
          RetailPrice: productDetails.RetailPrice,
          SalesPrice: productDetails.SalesPrice,
          ConfigurableProductSKU: !isProductNa
            ? productDetails.ConfigurableProductSKU
                : productDetails.SKU,

          PublishProductId: productDetails.PublishProductId,
          Price: productPrice,
          TierPriceList: formattedPriceTiers,          
        }));
      })
      .catch((error) => {
        notificationController.error({ message: error.message, placement: TOP_PLACEMENT });
      });
          
  };
  return (
    <Row className="size-swatch">
      <Col span={6} className="d-flex align-center">
        <Text className="text-color inp-label">
          {/* <strong>{translate("common.titleSize")}:</strong> */}
          <strong>{translate(variant[index])}:</strong>
        </Text>
      </Col>
      <Col span={18}>
        <Space size={5}>
          {configurableAttributes.map((e, i) => {
            return (
              <div
                key={i}
                className="color-swatch-container d-flex"
                onClick={() => variantSelectHandler(e.AttributeValue)}
              >
                <div
                  className={
                    e.AttributeValue === (selectedVariant && selectedVariant?.defaultVariant[index])
                      ? variant[index] === "Color"
                        ? "c-addon-item active"
                        : "size-addon-item active"
                      : variant[index] === "Color"
                      ? "c-addon-item"
                      : "size-addon-item"
                  }
                  style={{ background: variant[index] === "Color" ? e.SwatchText : "" }}
                  title={e.AttributeValue}
                >
                  {variant[index] === "Color" ? "" : e.AttributeValue}
                  {variant[index] === "Color"
                    ? e.AttributeValue == Znode_NA_Code
                      ? e.AttributeValue
                      : ""
                    : ""}
                </div>
              </div>
            );
          })}
        </Space>
      </Col>
    </Row>
  );
};

export default VariantSelection;


function NAConfigurableProduct(attributeValue: string, selectCustomAttribute: ICustomAttribute[], variant: string[], index: number, customattirbutesData: ICustomAttribute[], setCustomatrribute: React.Dispatch<React.SetStateAction<ICustomAttribute[]>>) {
  const customattirbute: ICustomAttribute = {
    AttributeCode: variant[index],
    AttributeValues: attributeValue,    
  };
  if (attributeValue == Znode_NA_Code) { 
    if (selectCustomAttribute.length == 0) {     
      customattirbutesData = [customattirbute];
      setCustomatrribute([customattirbute]);
    } else {
      const tableData: ICustomAttribute[] = [...selectCustomAttribute];
      const isVarientAvailable = tableData?.find(
        (x) => x.AttributeCode == variant[index] && x.AttributeValues == attributeValue
      );
      if (isVarientAvailable == null) {
        const attributeCode = tableData?.find((x) => x.AttributeCode == variant[index]);
        if (attributeCode != null) {
          const indexSplice = tableData?.findIndex(
            (x) => x.AttributeCode == variant[index]
          );
          tableData.splice(indexSplice, 1);   
        }
        tableData.push(customattirbute);
        customattirbutesData = tableData;
        setCustomatrribute(tableData);
      }
    }
  } else {
    if (selectCustomAttribute.length != 0) {
      const tableData: ICustomAttribute[] = [...selectCustomAttribute];
      const attributeCode = tableData?.find((x) => x.AttributeCode == variant[index]);
      if (attributeCode != null) {
        const indexSplice = tableData?.findIndex((x) => x.AttributeCode == variant[index]);
        tableData.splice(indexSplice, 1);
        customattirbutesData = tableData;
        setCustomatrribute(tableData);
      }
      const custattirbute: ICustomAttribute = {
        AttributeCode: variant[index],
        AttributeValues: attributeValue,       
      };
      const isVarientAvailable = tableData?.find((x) => x.AttributeCode == variant[index]);
      if (isVarientAvailable == null) {
        tableData.push(custattirbute);
        customattirbutesData = tableData;
        setCustomatrribute(tableData);
      }
    }
  }
  return customattirbutesData;
}