import React, { useState } from "react";
import { IProductDescription } from "interfaces/ClientInterface/IProducts";
import { Typography } from "antd";
import { translate } from "i18n";
const { Paragraph } = Typography;

const ProductDescription = (props: IProductDescription) => {
  const { descClass, descriptionData } = props;
  const [ellipsis] = useState(true);
  return (
    <>
      <div className={descClass}>
        <Paragraph
          ellipsis={
            ellipsis
              ? { rows: 2, expandable: true, symbol: translate("common.textReadMore") }
              : false
          }
        >
          {descriptionData?.replace(/<[^>]*>/g, " ")}
        </Paragraph>
      </div>
    </>
  );
};

export default ProductDescription;
