import React from "react";
import { Image } from "antd";
import { IProductsImage } from "interfaces/ClientInterface/IProducts";
import NoImage from "../../../assets/images/no-image.png";

const ProductImage = (props: IProductsImage) => {
  const { imageWidth, imageHeight, isPreview, className, imageUrl } = props;
  return (
    <Image
      className={className}
      src={imageUrl}
      preview={isPreview}
      width={imageWidth}
      height={imageHeight}
      fallback={NoImage}
    />
  );
};

export default ProductImage;
