/* eslint-disable react/no-unescaped-entities */
import React from "react";
import { Space, Typography } from "antd";
import { IProductPrice } from "interfaces/ClientInterface/IProducts";
import { translate } from "i18n";
//import { ICustomAttribute } from "interfaces/APIInterface/IProducts";

const { Title, Text } = Typography;

const ProductPrice = (props: IProductPrice ) => {
  // eslint-disable-next-line max-len
  const { priceClass, currency, price, priceFontLevel, inStockQuantity,showStock} = props;
 
  // eslint-disable-next-line 
  return (
    
    <Space direction="vertical" size={1} className="d-flex">
      {price != null ? (
        <Title level={priceFontLevel} className={priceClass}>
          {!showStock && currency}
          {price}
        </Title>
      ) : null}
    
      {!showStock && (
        <Text type="success" className="stock-define-color">
          <strong>
            {translate("products.textInStock")} ({inStockQuantity})
          </strong>
        </Text>
      )}
    </Space>
  );
};

export default ProductPrice;
