import React from "react";
import { Space, Typography } from "antd";
import { ISku } from "interfaces/ClientInterface/IProducts";
import { translate } from "i18n";

const { Text } = Typography;

const ProductSku = (props: ISku) => {
  const { productSku, labelClass } = props;
  return (
    <Space size={10}>
      <Text className={labelClass}>
        <strong>{translate("products.textSku")}:</strong> {productSku}
      </Text>
    </Space>
  );
};

export default ProductSku;
