import React from "react";
import CollapseComponent from "../Collapse/Collapse";
import { Collapse } from "antd";
import { IProductDescriptionProp, ICollapseItem } from "interfaces/ClientInterface/IProducts";

const { Panel } = Collapse;
const ProductSpecification: React.FC<IProductDescriptionProp> = ({
  productSpecificationData,
}: IProductDescriptionProp) => {
  return (
    <CollapseComponent
      isAccordion={true}
      customPanel={true}
      size="small"
      title=""
      dataTestSelector="collapseProductDescription"
    >
      <>
        {productSpecificationData &&
          productSpecificationData.map((item: ICollapseItem) => {
            return (
              <Panel
                header={item.title}
                key={item.key}
                className={"collapse-panel-style" + " " + item.classSelector}
              >
                <div dangerouslySetInnerHTML={{ __html: item.content }} />
              </Panel>
            );
          })}
      </>
    </CollapseComponent>
  );
};

export default ProductSpecification;
