import React from "react";
import { Space, Table } from "antd";
import Heading from "../Heading/Heading";
import { IPriceTierProp } from "interfaces/ClientInterface/IProducts";

const ProductTier: React.FC<IPriceTierProp> = ({
  productQuantityTierColumn,
  productPriceTierColumn,
}: IPriceTierProp) => {
  return (
    <Space direction="vertical" size={5} className="d-flex price-tiers">
      <Heading titleClass="section-heading m-0" titleText="Price Tiers" textFontLevel={5} />
      <Table
        dataSource={[productPriceTierColumn]}
        columns={productQuantityTierColumn}
        pagination={false}
        scroll={{ x: "max-content" }}
        data-test-selector="tblList"
        className={"price-tiers-listing"}
        loading={productQuantityTierColumn && productQuantityTierColumn.length ? false : true}
      />
    </Space>
  );
};

export default ProductTier;
