/* eslint-disable @typescript-eslint/no-explicit-any */
/* eslint-disable max-len */
/* eslint-disable no-console */
/* eslint-disable max-lines */
/* eslint-disable max-lines-per-function */
import React, { FC, useEffect, useState } from "react";
import ModalComponent from "../Modal/Modal";
import {
  Button,
  Col,
  Row,
  Space,
  Typography,
  Input,
  Divider,
  Upload,
  Spin,
  Select,
  UploadProps,
  message,
  UploadFile,
  Image,
} from "antd";
import { CloseCircleOutlined, FileTextOutlined } from "@ant-design/icons";
import { IQuickAddProps, IQuickListProps } from "interfaces/ClientInterface/IQuickAddModal";

const { Text, Title } = Typography;
const { TextArea } = Input;
import "./QuickAddModal.scss";
import { DEFAULT_EMPTY_GUID, DOWNLOAD_CSV_TEMPLATE, TOP_PLACEMENT } from "config/constant";
import {
  IAddProductProp,
  IKeywordSearchRequest,
  IOnClickProductParameter,
  IOrderProductCatalogProfile,
  IProduct,
  IProductVariant,
  IQuickOrderParameter,
} from "interfaces/APIInterface/IProducts";
import { IOrder } from "interfaces/ClientInterface/IEditOrder";
import {
  addProduct,
  getOrderProductCatalogProfileDetails,
  getProductDetails,
  getQuickOrderProductList,
  keywordSearchSuggestion,
  parseFileIntoQuickOrderCartArray,
} from "api/services/addProduct.api";
import { notificationController } from "../Notification/Notification";
import {
  ERROR_INVALID_EXTENSION_SELECTED,
  ERROR_INVALID_SKU,
  ERROR_PRODUCT_NOT_PRESENT,
  ERROR_QUICK_LIST_LIMIT,
  GET_ORDER_DETAILS_FAILED,
  QUICK_ADD_PRODUCTS_FAILED,
  QUICK_ADD_PRODUCTS_SUCCESS,
} from "../Product/Product.Constant";
import Loader from "../Loader/Loader";
import { IQuickOrder, IQuickOrderCart } from "interfaces/ClientInterface/IQuickViewOrder";
import { getOrder } from "api/services/editOrder.api";
import { RcFile, UploadChangeParam } from "antd/es/upload";
import { useParams } from "react-router-dom";
import { readUserId } from "api/services/localStorage.service";
import { translate } from "i18n";
import { IQuickOrderProduct } from "interfaces/APIInterface/IQuickViewOrder";
import { deepCloneArray } from "utils";
const { Option } = Select;
let isDuplicateSku = false;
const QuickAddModal: FC<IQuickAddProps> = ({
  open,
  setOpen,
  refreshListOnBulkAdd,
  calculateOrder,
  getOrderDetailsSKU,
}: IQuickAddProps) => {
  const [searchTerm, setSearchTerm] = useState<string>("");
  const [skuList, setSkuList] = useState("");
  const [skuValue, setSkuValue] = useState<boolean>(false);
  const [index, setIndex] = useState(-1);
  const [loader, setLoader] = useState({
    quickOrderProductsLoading: false,
  });
  // eslint-disable-next-line no-unused-vars
  const [isUploadFile, setIsUploadFile] = useState<boolean>(true);
  const [isShowValidationMessage, setIsShowValidationMessage] = useState<boolean>(false);
  const [isAllValidate, setIsAllValidate] = useState<boolean>(false);
  const [isCallFromCsvAndQuickAdd, setIsCallFromCsvAndQuickAdd] = useState<boolean>(false);
  const [productListData, setProductListData] = useState<IProduct[]>([]);
  const [onClickProductData, setOnClickProductData] = useState<IOnClickProductParameter>(
    {} as IOnClickProductParameter
  );

  const { orderId } = useParams<Record<string, string | undefined>>();
  const initialRows = [
    {
      name: "",
      znodeProductId: "",
      quantity: "",
      versionId: "",
      error: "",
    },
    {
      name: "",
      znodeProductId: "",
      quantity: "",
      versionId: "",
      error: "",
    },
    {
      name: "",
      znodeProductId: "",
      quantity: "",
      versionId: "",
      error: "",
    },
    {
      name: "",
      znodeProductId: "",
      quantity: "",
      versionId: "",
      error: "",
    },
    {
      name: "",
      znodeProductId: "",
      quantity: "",
      versionId: "",
      error: "",
    },
  ];
  const [addRowValue, setAddRowValue] = useState<IQuickListProps[]>(
    JSON.parse(JSON.stringify(initialRows))
  );

  useEffect(() => {
    if (searchTerm?.trim() != "") {
      getOrderDetailsAndProductList();
    } else {
      setProductListData([]);
    }
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [searchTerm]);

  const onClear = () => {
    const initialData = deepCloneArray(initialRows);
    setAddRowValue([]);
    setIsCallFromCsvAndQuickAdd(false);
    setSkuValue(false);
    setTimeout(() => {
      setAddRowValue(
        initialData.map(() => {
          return {
            name: "",
            znodeProductId: "",
            quantity: "",
            versionId: "",
            error: "",
            sku: "",
            imageSmallPath: "",
            isValid: "",
          };
        })
      );
    });
  };

  const onAddRowPress = () => {
    setAddRowValue((prevState) => {
      const addRowData: IQuickListProps[] = [...prevState];
      addRowData.push({
        name: "",
        znodeProductId: "",
        quantity: "",
        versionId: "",
        error: "",
        sku: "",
        imageSmallPath: "",
        isValid: "",
      });

      return addRowData;
    });
  };

  const deleteRow = (index: number) => {
    setAddRowValue((prevState) => {
      const addRowData: IQuickListProps[] = [...prevState];
      addRowData.splice(index, 1);
      return addRowData;
    });
  };

  // eslint-disable-next-line @typescript-eslint/no-explicit-any
  const onChangeHandler = async (text: string, field: string, index: number, option: any) => {
    if (field == "sku") {
      const orderDetails: IOnClickProductParameter = await onProductClick(option?.key);

      setAddRowValue((prevState) => {
        const filterData: IQuickListProps[] = [...prevState];
        const row: IQuickListProps = filterData[index];
        row[field as keyof IQuickListProps] = option?.value;
        filterData[index].sku = row?.sku;
        filterData[index].quantity = option?.Quantity ?? "1";
        filterData[index].name = option?.name;
        filterData[index].versionId = option?.versionId ?? "0";
        filterData[index].znodeProductId =
          orderDetails.PublishProductId?.toString() ?? option?.key ?? "0";
        filterData[index].isValid = "";
        filterData[index].error = "";
        filterData[index].price = orderDetails?.RetailPrice.toString() ?? "0";
        return filterData;
      });
    } else if (field == "quantity") {
      setAddRowValue((prevState) => {
        const filterData: IQuickListProps[] = [...prevState];
        //filterData.forEach((element) => {
        if (isCallFromCsvAndQuickAdd) {
          for (let i = 0; i < filterData?.length; i++) {
            if (parseInt(filterData[i]?.quantity) >= 0) {
              setIsAllValidate(false);
            } else if (
              filterData[i]?.quantity == "" ||
              filterData[i]?.quantity == "0" ||
              filterData[i]?.quantity.startsWith("-")
            ) {
              setIsAllValidate(false);
            } else {
              setIsAllValidate(true);
              break;
            }
          }
        } else {
          if (parseInt(text) >= 0) {
            setIsAllValidate(false);
            setIsShowValidationMessage(false);
          } else {
            setIsShowValidationMessage(true);
            setIsAllValidate(true);
          }
        }

        // });
        const row: IQuickListProps = filterData[index];
        row[field as keyof IQuickListProps] = option?.value;
        filterData[index] = row;
        filterData[index].quantity = text ?? "1";
        filterData[index].error = "";
        return filterData;
      });
    }
    setProductListData([]);
  };
  const onProductClick = async (productId: string) => {
    const paramProductId = Number(productId);
    const orderDetails: IOrder = await getOrderDetails(orderId);
    const productCatalogData: IOrderProductCatalogProfile =
      await fetchOrderProductCatalogProfileDetails(orderDetails?.UserId, orderDetails?.PortalId);
    return await getProductDetails(
      paramProductId,
      productCatalogData.CatalogId,
      orderDetails.LocaleId,
      orderDetails.PortalId,
      ""
    )
      .then((response) => {
        const onProductsParams = response?.PublishProduct;
        setOnClickProductData(onProductsParams);
        setLoading("quickOrderProductsLoading", false);
        return onProductsParams;
      })
      .catch((err) => {
        notificationController.error({ message: err.message, placement: TOP_PLACEMENT });
      });
  };

  // eslint-disable-next-line max-len
  const validateProductSKUs = async (
    quickOrderCart: IQuickOrderCart[],
    quickOrder: IQuickOrder
  ) => {
    if (quickOrderCart?.length > 0 && quickOrder != null) {
      const productSKu: string = quickOrderCart.map((item) => item.SKU).join(",");
      const quickOrderParameter: IQuickOrderParameter = { SKUs: productSKu };
      const orderDetails: IOrder = await getOrderDetails(orderId);
      const productCatalogData: IOrderProductCatalogProfile =
        await fetchOrderProductCatalogProfileDetails(orderDetails?.UserId, orderDetails?.PortalId);
      await getQuickOrderProductList(
        quickOrderParameter,
        productCatalogData.CatalogId,
        orderDetails.LocaleId,
        orderDetails.PortalId
      )
        .then((response) => {
          quickOrder.productDetail = response.Products;
          setLoading("quickOrderProductsLoading", false);
        })
        .catch((err) => {
          notificationController.error({ message: err.message, placement: TOP_PLACEMENT });
        });
      let uniqueId: number = Math.random();
      quickOrder.validSKUCount = 0;
      quickOrder.productDetail.forEach((product) => {
        product.UniqueId = uniqueId;
        product.Quantity = Number(
          quickOrderCart.find((item) => item.SKU === product.SKU)?.Quantity
        );
        if (product.IsActive) {
          uniqueId = uniqueId + 1;
        }
      });
      quickOrder.validSKUCount = quickOrder.productDetail.filter((item) => item.IsActive).length;
      quickOrder.invalidSKUCount = quickOrderCart.length - quickOrder.validSKUCount;
      quickOrder.isSuccess = true;
    } else {
      quickOrder.isSuccess = false;
    }
    return quickOrder;
  };

  /**
   * This function is used to merge duplicate SKUs.
   */
  const mergeDuplicateSKUs = (quickOrderCart: IQuickOrderCart[]) => {
    if (quickOrderCart?.length > 0) {
      const skuList: string[] = quickOrderCart.map((o) => o.SKU);
      const duplicateSKUs: string[] = skuList.filter(
        (currentValue, currentIndex) => skuList.indexOf(currentValue) !== currentIndex
      );
      if (duplicateSKUs?.length > 0) {
        isDuplicateSku = true;
      }
    }
    return quickOrderCart;
  };

  /**
   * This function is used to extract sku in valid form.
   */
  const extractValidSKUs = (productSKUText: string) => {
    const quickOrderCartItems: IQuickOrderCart[] = [];
    if (productSKUText != null) {
      const rg = new RegExp(
        "^(?<sku>[a-zA-Z0-9_-]*\\b[a-zA-Z0-9_-]*)[\\s|,]*(?<quantity>[0-9]*)[\\s]*$"
      );
      const skuList: string[] = productSKUText.split(new RegExp("\\r\\n|\\n|\\r| "));
      for (let index = 0; index < skuList?.length; index++) {
        let sku = "";
        let quantity = 0;
        const matches: RegExpMatchArray | null = rg.exec(skuList[index]);
        if (matches) {
          if (matches.groups != undefined) {
            sku = String(matches.groups["sku"]);
            quantity =
              Number(matches.groups["quantity"]) != 0 ? Number(matches.groups["quantity"]) : 1;
          }
          if (sku?.length > 0) {
            const quickOrderCartItem: IQuickOrderCart = { Id: 0, SKU: sku, Quantity: quantity };
            quickOrderCartItems.push(quickOrderCartItem);
          }
        }
      }
    }
    return quickOrderCartItems;
  };

  /**
   * This function removes valid SKUs from item number field
   */
  const removeValidProductSKUs = (quickOrder: IQuickOrder) => {
    if (quickOrder?.productDetail?.length > 0) {
      const skuList: string[] = quickOrder.productDetail.map((m) => m.SKU);
      const validSkuList: string[] = quickOrder.productSKUText.split(new RegExp("\\r\\n|\\n|\\r"));
      if (skuList?.length > 0 && validSkuList?.length > 0) {
        validSkuList.filter((m) => skuList.some((x) => x?.length > 0 && m.includes(x)));
      }
      quickOrder.productSKUText = skuList.join("\r\n");
    }
  };

  /**
   * This function removes valid SKUs from item number field
   */
  const removeValidProductSKUsFromFile = (
    quickOrder: IQuickOrder,
    quickOrderCart: IQuickOrderCart[]
  ) => {
    if (quickOrder?.productDetail?.length > 0) {
      const skuList: string[] = quickOrder.productDetail.map((m) => m.SKU);
      const cartSkuList: string[] = quickOrderCart.map((x) => x.SKU);
      if (skuList?.length > 0 && cartSkuList?.length > 0) {
        cartSkuList.filter((m) => skuList.some((x) => x?.length > 0 && m.includes(x)));
      }
      quickOrder.productSKUText = cartSkuList.join("\r\n");
    }
  };

  //This method is to set quick order notification
  const setQuickOrderNotification = (quickOrder: IQuickOrder) => {
    let message = "";
    let description = "";
    quickOrder.isSuccess = quickOrder.validSKUCount > 0;
    if (quickOrder.validSKUCount > 0 && quickOrder.invalidSKUCount > 0) {
      message = message != null ? message : message;
      message +=
        quickOrder.validSKUCount == 1 && quickOrder.invalidSKUCount == 1
          ? quickOrder.validSKUCount.toString() + translate("quickAdd.productValidSku")
          : quickOrder.validSKUCount.toString() + translate("quickAdd.productsValidSku");

      description = description != null ? description : description;
      description +=
        quickOrder.validSKUCount == 1 && quickOrder.invalidSKUCount == 1
          ? quickOrder.invalidSKUCount + translate("quickAdd.InValidProduct")
          : quickOrder.invalidSKUCount.toString() + translate("quickAdd.InValidProducts");
    } else if (quickOrder.validSKUCount > 0) {
      message = message != null ? message : message;
      message +=
        quickOrder.validSKUCount == 1
          ? quickOrder.validSKUCount.toString() + translate("quickAdd.productValidSku")
          : quickOrder.validSKUCount.toString() + translate("quickAdd.productsValidSku");
    } else if (quickOrder.invalidSKUCount > 0) {
      message = message != null ? message : message;
      message +=
        quickOrder.invalidSKUCount == 1
          ? quickOrder.invalidSKUCount.toString() + translate("quickAdd.InValidProduct")
          : quickOrder.invalidSKUCount.toString() + translate("quickAdd.InValidProducts");
    } else if (quickOrder.validSKUCount == 0 && quickOrder.invalidSKUCount == 0) {
      message = translate("quickAdd.ErrorInProductList");
    }
    quickOrder.notificationMessage = message;
    quickOrder.notificationDescription = description;
  };

  //append SKU data from SKU List box to Quick List rows
  const appendSKUListToQuickList = async (quickOrder: IQuickOrder) => {
    setAddRowValue(() => {
      const addRowData: IQuickListProps[] = [];

      quickOrder?.productDetail.map(async (el: IQuickOrderProduct) => {
        const orderDetails: IOnClickProductParameter = await onProductClick(el.Id.toString());
        await addRowData.push({
          name: el?.Name,
          znodeProductId: orderDetails?.PublishProductId?.toString(),
          quantity: el?.Quantity?.toString(),
          versionId: el?.VersionId?.toString(),
          error: "",
          sku: el?.SKU,
          imageSmallPath: "",
          isValid: "",
          price: orderDetails.RetailPrice.toString(),
        });
      });

      return addRowData;
    });
  };

  //remove items from quick list if it is greater than 50 rows.
  const limitQuickOrderUptoFiftyRecords = (quickOrder: IQuickOrder) => {
    if (addRowValue.length > 51) {
      addRowValue.splice(51, addRowValue.length);
      quickOrder.notificationMessage = ERROR_QUICK_LIST_LIMIT;
      quickOrder.isSuccess = false;
    }
  };

  //display appropriate message for quick list products add status
  const setNotificationMessageForQuickList = (quickOrder: IQuickOrder) => {
    if (quickOrder.notificationMessage.length > 0) {
      if (quickOrder.isSuccess)
        notificationController.success({
          message: quickOrder.notificationMessage,
          description: quickOrder.notificationDescription,
          placement: TOP_PLACEMENT,
        });
      else
        notificationController.error({
          message: quickOrder.notificationMessage,
          placement: TOP_PLACEMENT,
        });
    } else {
      notificationController.error({
        message: ERROR_PRODUCT_NOT_PRESENT,
        placement: TOP_PLACEMENT,
      });
    }
  };

  //Add products from SKU List to Quick List
  const addProductToQuickList = async () => {
    setIsCallFromCsvAndQuickAdd(true);
    setSkuValue(true);
    isDuplicateSku = false;
    const productDetails: IQuickOrderProduct[] = [];

    let combinedData;
    if (skuList.length > 0) {
      let csrSKU = "";
      addRowValue.forEach((row) => {
        if (Number(row.znodeProductId) > 0) {
          csrSKU = `${row.sku},${row.quantity}` + " " + csrSKU.trim();
        }
      });
      const trimmedSkuList = skuList.replace(/\s+/g, " ").trim();
      combinedData = trimmedSkuList + " " + csrSKU.trim();
      let quickOrder: IQuickOrder = {
        productSKUText: combinedData,
        validSKUCount: 0,
        invalidSKUCount: 0,
        isSuccess: false,
        notificationMessage: "",
        name: "",
        id: "",
        productDetail: productDetails,
        quantity: 0,
      };
      quickOrder = await validateProductSKUs(
        mergeDuplicateSKUs(extractValidSKUs(combinedData)),
        quickOrder
      );

      const skuListOfdata: string[] = combinedData.split(new RegExp("\\r\\n|\\n|\\r| "));
      const invalidSkuList = skuListOfdata.filter((el) => {
        const skuArr = el.split(",");
        const index: number = quickOrder.productDetail.findIndex(
          (x) => x.SKU == skuArr?.[0]?.trim()
        );
        return index == -1 ? true : false;
      });

      // eslint-disable-next-line no-unused-vars

      if (isDuplicateSku) {
        const resOfDuplicateSkuList: IQuickListProps[] = [];

        skuListOfdata.map((item) => {
          const subItem = item?.split(",");
          if (parseInt(subItem?.[1]) < 0) {
            setIsAllValidate(true);
          }
          const filterValue = invalidSkuList.filter((string) => {
            return string.includes(item);
          });

          if (filterValue.length == 0) {
            const filterznodeProductId = quickOrder.productDetail.filter(
              (productItem: IQuickOrderProduct) => {
                return productItem.SKU == subItem[0];
              }
            );
            resOfDuplicateSkuList.push({
              sku: subItem?.[0],
              quantity: subItem?.[1] || "1",
              name: filterznodeProductId[0]?.Name,
              znodeProductId: filterznodeProductId[0]?.Id,
              versionId: filterznodeProductId[0].VersionId?.toString(),
              error: "",
              imageSmallPath: "",
              isValid: "",
            });
          }
        });
        if (resOfDuplicateSkuList?.length) {
          quickOrder.validSKUCount = resOfDuplicateSkuList?.length;
          quickOrder.invalidSKUCount = invalidSkuList?.length;
          setAddRowValue([]);
          setAddRowValue(() => {
            const addRowData: IQuickListProps[] = [];

            resOfDuplicateSkuList.map(async (el) => {
              const orderDetails: IOnClickProductParameter = await onProductClick(
                el.znodeProductId.toString()
              );
              await addRowData.push({
                name: el?.name,
                znodeProductId: orderDetails?.PublishProductId?.toString(),
                quantity: el?.quantity?.toString(),
                versionId: el?.versionId?.toString(),
                error: "",
                sku: el?.sku,
                imageSmallPath: "",
                isValid: "",
                price: orderDetails.RetailPrice.toString(),
              });
            });

            return addRowData;
          });

          if (quickOrder.validSKUCount > 0) {
            removeValidProductSKUs(quickOrder);
          }
          if (quickOrder.productDetail.length > 50) {
            quickOrder.productDetail.splice(50, quickOrder.productDetail.length - 50);
            quickOrder.validSKUCount = 50;
          }
          setQuickOrderNotification(quickOrder);

          //remove items from quick list if it is greater than 50 rows.
          limitQuickOrderUptoFiftyRecords(quickOrder);
          setNotificationMessageForQuickList(quickOrder);
          setSkuList(invalidSkuList.join(" "));
        }
      } else {
        setSkuList(invalidSkuList.join(" "));
        appendSKUListToQuickList(quickOrder);
        if (quickOrder.validSKUCount > 0) {
          removeValidProductSKUs(quickOrder);
        }
        if (quickOrder.productDetail.length > 50) {
          quickOrder.productDetail.splice(50, quickOrder.productDetail.length - 50);
          quickOrder.validSKUCount = 50;
        }
        setQuickOrderNotification(quickOrder);

        //remove items from quick list if it is greater than 50 rows.
        limitQuickOrderUptoFiftyRecords(quickOrder);
        setNotificationMessageForQuickList(quickOrder);
      }
    }
  };

  const setLoading = (key: string, loaderState: boolean) => {
    setLoader((prevState) => ({
      ...prevState,
      [key]: loaderState,
    }));
  };

  // eslint-disable-next-line @typescript-eslint/no-explicit-any
  const addSpreadsheetToQuickList = async (fileInfo: UploadChangeParam<UploadFile<any>>) => {
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    const fileName: any = fileInfo?.file;
    const formData = new FormData();
    setIsCallFromCsvAndQuickAdd(true);
    setSkuValue(true);
    setIsAllValidate(false);
    formData.append("file", fileName);
    parseFileIntoQuickOrderCartArray(formData)
      .then(async (response) => {
        const quickOrderCart: IQuickOrderCart[] = JSON.parse(response);

        let result = "";
        quickOrderCart.forEach((item: IQuickOrderCart) => {
          if (result == "") {
            result = `${item.SKU},${item.Quantity}`;
          } else {
            result = result + " " + `${item.SKU},${item.Quantity}`;
          }
        });
        const productDetails: IQuickOrderProduct[] = [];
        let quickOrder: IQuickOrder = {
          productSKUText: result,
          validSKUCount: 0,
          invalidSKUCount: 0,
          isSuccess: false,
          notificationMessage: "",
          name: "",
          id: "",
          productDetail: productDetails,
          quantity: 1,
        };
        if (skuList.length > 0) {
          quickOrder.productSKUText = skuList;
        }

        quickOrder = await validateProductSKUs(
          mergeDuplicateSKUs(extractValidSKUs(result)),
          quickOrder
        );
        validateProductSKUs(mergeDuplicateSKUs(quickOrderCart), quickOrder);

        const skuListOfdata: string[] = result.split(new RegExp("\\r\\n|\\n|\\r| "));

        const invalidSkuList = skuListOfdata.filter((el) => {
          const skuArr = el.split(",");
          const index: number = quickOrder.productDetail.findIndex(
            (x) => x.SKU == skuArr?.[0]?.trim()
          );
          return index == -1 ? true : false;
        });
        if (isDuplicateSku) {
          const resOfDuplicateSkuList: IQuickListProps[] = [];

          skuListOfdata.map((item) => {
            const subItem = item?.split(",");
            if (parseInt(subItem?.[1]) < 0) {
              setIsAllValidate(true);
            }
            const filterValue = invalidSkuList.filter((string) => {
              return string.includes(item);
            });

            if (filterValue.length == 0) {
              const filterznodeProductId = quickOrder.productDetail.filter(
                (productItem: IQuickOrderProduct) => {
                  return productItem.SKU == subItem[0];
                }
              );
              resOfDuplicateSkuList.push({
                sku: subItem?.[0],
                quantity: subItem?.[1] || "1",
                name: filterznodeProductId[0]?.Name,
                znodeProductId: filterznodeProductId[0]?.Id,
                versionId: filterznodeProductId[0].VersionId?.toString(),
                error: "",
                imageSmallPath: "",
                isValid: "",
              });
            }
          });
          if (resOfDuplicateSkuList?.length) {
            quickOrder.validSKUCount = resOfDuplicateSkuList?.length;
            quickOrder.invalidSKUCount = invalidSkuList?.length;

            setAddRowValue(() => {
              const addRowData: IQuickListProps[] = [];

              resOfDuplicateSkuList.map(async (el) => {
                const orderDetails: IOnClickProductParameter = await onProductClick(
                  el?.znodeProductId?.toString()
                );
                await addRowData.push({
                  name: el?.name,
                  znodeProductId: orderDetails?.PublishProductId?.toString(),
                  quantity: el?.quantity?.toString(),
                  versionId: el?.versionId?.toString(),
                  error: "",
                  sku: el?.sku,
                  imageSmallPath: "",
                  isValid: "",
                  price: orderDetails.RetailPrice.toString(),
                });
              });

              return addRowData;
            });

            setSkuList(invalidSkuList.join(" "));
            if (quickOrder.validSKUCount > 0) {
              removeValidProductSKUsFromFile(quickOrder, quickOrderCart);
            } else {
              const skuList: string[] = quickOrderCart.map((x) => x.SKU);
              quickOrder.productSKUText = skuList.join("\r\n");
            }
            if (quickOrder.productDetail.length > 50) {
              quickOrder.productDetail.splice(50, quickOrder.productDetail.length - 50);
              quickOrder.validSKUCount = 50;
            }

            setQuickOrderNotification(quickOrder);

            limitQuickOrderUptoFiftyRecords(quickOrder);
            setNotificationMessageForQuickList(quickOrder);
          }
        } else {
          setSkuList(invalidSkuList.join(" "));
          if (quickOrder.validSKUCount > 0) {
            removeValidProductSKUsFromFile(quickOrder, quickOrderCart);
          } else {
            const skuList: string[] = quickOrderCart.map((x) => x.SKU);
            quickOrder.productSKUText = skuList.join("\r\n");
          }
          if (quickOrder.productDetail.length > 50) {
            quickOrder.productDetail.splice(50, quickOrder.productDetail.length - 50);
            quickOrder.validSKUCount = 50;
          }

          setQuickOrderNotification(quickOrder);
          //append Valid product SKU List to Quick List
          appendSKUListToQuickList(quickOrder);
          //remove items from quick list if it is greater than 50 rows.
          limitQuickOrderUptoFiftyRecords(quickOrder);
          setNotificationMessageForQuickList(quickOrder);
        }
      })
      .catch((err) => {
        notificationController.error({ message: err.message, placement: TOP_PLACEMENT });
      });
  };

  const setSearchRequestModel = (
    orderData: IOrder,
    orderProductCatalogProfileDetails: IOrderProductCatalogProfile
  ) => {
    const searchRequest: IKeywordSearchRequest = {
      CatalogId: orderProductCatalogProfileDetails?.CatalogId,
      LocaleId: orderData?.LocaleId,
      PageSize: 10,
      PortalId: orderData?.PortalId,
      Keyword: searchTerm,
    };
    return searchRequest;
  };

  /**
   * This function is used to get the list of products by sending ISearchRequest as a parameter
   */
  const fetchProductList = (
    orderData: IOrder,
    orderProductCatalogProfileDetails: IOrderProductCatalogProfile
  ) => {
    const searchRequest: IKeywordSearchRequest = setSearchRequestModel(
      orderData,
      orderProductCatalogProfileDetails
    );

    keywordSearchSuggestion(searchRequest)
      .then((response) => {
        const productDataList: IProduct[] = response.Search?.Products;
        if (productDataList?.length > 0) setProductListData(productDataList);
        else {
          const field = "error";
          setAddRowValue((prevState) => {
            const filterData: IQuickListProps[] = [...prevState];
            const row: IQuickListProps = filterData[index];
            row[field as keyof IQuickListProps] = ERROR_INVALID_SKU;
            filterData[index].sku = searchTerm;
            filterData[index] = row;
            return filterData;
          });
        }
      })
      .catch((err) => {
        notificationController.error({ message: err.message, placement: TOP_PLACEMENT });
      });
  };

  /**
   * This function is used to download csv template for bulk add
   */
  const downloadQuickOrderTemplate = (fileFormat: string) => {
    window.location.href = DOWNLOAD_CSV_TEMPLATE + encodeURIComponent(fileFormat);
  };

  const getOrderDetailsAndProductList = async () => {
    const orderData: IOrder = await getOrderDetails(orderId);
    const orderProductCatalogProfileDetails: IOrderProductCatalogProfile =
      await fetchOrderProductCatalogProfileDetails(orderData?.UserId, orderData?.PortalId);
    searchTerm.length >= 3 && fetchProductList(orderData, orderProductCatalogProfileDetails);
  };

  /**
   * This function is used to get the order summary details.
   */
  const getOrderDetails = async (orderId: string | undefined) => {
    return await getOrder(orderId)
      .then((response) => {
        return response?.Order;
      })
      .catch(() => {
        notificationController.error({ message: GET_ORDER_DETAILS_FAILED });
      });
  };

  /**
   * This function is used to get the order product catalog and user profile details
   */
  const fetchOrderProductCatalogProfileDetails = async (userId: number, portalId: number) => {
    return await getOrderProductCatalogProfileDetails(userId, portalId)
      .then((response) => {
        return response?.OrderProductCatalogProfile;
      })
      .catch(() => {
        notificationController.error({ message: GET_ORDER_DETAILS_FAILED });
      });
  };

  const addSkuList = (event: { target: { value: React.SetStateAction<string> } }) => {
    setSkuList(event.target.value);
  };
  /**
   * This function is used when the product needs to be added to the order.
   */
  const addProductsToQuickOrder = () => {
    const productVariants: IProductVariant[] = [];
    // eslint-disable-next-line no-console, no-unused-vars, @typescript-eslint/no-unused-vars
    let versionIds = 0;
    addRowValue.forEach((row) => {
      if (Number(row.znodeProductId) > 0) {
        const productVariant: IProductVariant = {
          ZnodeProductId: Number(row.znodeProductId),
          GroupingCode: "",
          IsAddOn: false,
          ParentDetail: "",
          Customization: "",
          Quantity: Number(row.quantity),
          Price: row?.price,
          ProductNote: "",
          Attributes: [],
          NAAttribute: [],
          ParentProductId:Number(row.znodeProductId),
        };
        productVariants.push(productVariant);
        versionIds = Number(row.versionId);
      }
      setSkuValue(false);
    });

    const productModel: IAddProductProp = {
      OrderId: orderId,
      VersionId: versionIds,
      ProductVariantDetails: productVariants,
      UserId: readUserId(),
      OrderProductId: DEFAULT_EMPTY_GUID,
      OrderProductAttributeValueId: null,
      ConfigurableProductSKU: onClickProductData?.ConfigurableProductSKU,
      SKU: onClickProductData.SKU, 

    };


    addProduct(productModel)
      .then((response) => {
        if (response.StatusModel && response.StatusModel.Status) {
          notificationController.success({
            message: QUICK_ADD_PRODUCTS_SUCCESS,
            placement: TOP_PLACEMENT,
          });
          onClear();
          calculateOrder();
          setOpen(false);
          setSkuList("");
          refreshListOnBulkAdd && refreshListOnBulkAdd();
        } else {
          notificationController.error({
            message: QUICK_ADD_PRODUCTS_FAILED,
            placement: TOP_PLACEMENT,
          });
        }
      })
      .catch(() => {
        notificationController.error({
          message: QUICK_ADD_PRODUCTS_FAILED,
          placement: TOP_PLACEMENT,
        });
      });
  };

  // eslint-disable-next-line @typescript-eslint/no-explicit-any
  const customRequest = (file: any) => {
    setIsUploadFile(false);
    addSpreadsheetToQuickList(file);
  };

  const fileUploadprops: UploadProps = {
    name: "file",
    showUploadList: false,
    beforeUpload(file: RcFile) {
      const allowedExtensionsArray: string[] = [
        "text/csv",
        "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet",
        "xls",
        "xlsx",
      ];
      if (!allowedExtensionsArray.includes(file.type)) {
        message.error(ERROR_INVALID_EXTENSION_SELECTED);
        return false;
      } else return true;
    },
  };

  return (
    <ModalComponent
      title={"BULK ADD"}
      visible={open}
      onCancel={() => {
        onClear();
        setOpen(false);
        setSkuList("");
      }}
      dataTestSelector="popQuickAdd"
      zIndex={10}
      isMaskClosable={true}
      footer={null}
      className="standard-modal"
      modalWidth="950px"
      bodyStyle={{ overflowY: "auto", maxHeight: "calc(100vh - 150px)" }}
    >
      <Row gutter={16} className="bulk-add-container">
        <Col
          className="gutter-row add-row-left-col"
          span={15}
          xs={24}
          sm={24}
          md={12}
          lg={15}
          xl={15}
        >
          <>
            <Title className="m-0 text-uppercase quick-add-sub-title">
              {translate("quickAdd.titleQuickList")}
            </Title>
            <div className="quick-list-container mt-16">
              {addRowValue &&
                addRowValue?.length > 0 &&
                addRowValue.map((item: IQuickListProps, i: number) => {
                  return (
                    <Row className="row-item mb-15" key={`row${i}`}>
                      <Col span={14} xs={9} sm={9} md={9} lg={14} xl={14} className="mr-15">
                        <Select
                          className="w-100"
                          showSearch
                          placeholder={translate("quickAdd.placeholderEnterSku")}
                          value={item.sku || undefined}
                          // eslint-disable-next-line @typescript-eslint/no-explicit-any
                          onChange={(selectedText: string, option: any): void => {
                            onChangeHandler(selectedText, "sku", i, option);
                            setSkuValue(true);
                          }}
                          notFoundContent={
                            loader?.quickOrderProductsLoading ? <Spin size="small" /> : null
                          }
                          filterOption={true}
                          onSearch={(searchTerm: string) => {
                            setSearchTerm(searchTerm);
                            setIndex(i);
                          }}
                          data-test-selector="drpQuickProductsList"
                          loading={loader?.quickOrderProductsLoading}
                          optionLabelProp="label"
                        >
                          {productListData?.map((x: IProduct) => {
                            return (
                              <Option
                                label={x.SKU}
                                value={x.SKU}
                                key={x.ZnodeProductId}
                                name={x.Name}
                                versionId={x.VersionId}
                              >
                                <div className="d-flex justify-between align-start">
                                  <Space direction="vertical">
                                    <div className="wrap-text">{x.Name}</div>
                                    <div>{x.SKU}</div>
                                  </Space>
                                  <Image src={x.ImageThumbNailPath} width={20} />
                                </div>
                              </Option>
                            );
                          })}
                        </Select>

                        <span className="error">{item && item.error}</span>
                      </Col>

                      <Col span={6} xs={9} sm={9} md={8} lg={6} xl={6} className="mr-15">
                        <Input
                          data-test-selector="txtProductQty"
                          placeholder=""
                          id={`enter-qty-${i}`}
                          value={item.quantity || undefined}
                          onChange={(e) => {
                            onChangeHandler(e.target.value, "quantity", i, null);
                          }}
                        />
                        {parseInt(item?.quantity) < 0 || (isShowValidationMessage && item?.sku) ? (
                          <span className="error">
                            {translate("quickAdd.ErrorForQuantityValidation")}
                          </span>
                        ) : (
                          ""
                        )}
                      </Col>
                      <Col
                        span={2}
                        xs={2}
                        sm={2}
                        md={4}
                        lg={2}
                        xl={2}
                        style={
                          i == 0
                            ? { display: "none" }
                            : { display: "flex", alignItems: "center", justifyContent: "center" }
                        }
                      >
                        <CloseCircleOutlined
                          onClick={() => {
                            deleteRow(i);
                          }}
                          style={i == 0 ? { display: "none" } : { color: "#f00" }}
                        />
                      </Col>
                    </Row>
                  );
                })}
            </div>
            <Space className="d-flex justify-end mt-24">
              <Button
                type="primary"
                data-test-selector={"btnAddRow"}
                onClick={onClear}
                className="text-uppercase"
              >
                {translate("quickAdd.btnClearAll")}
              </Button>
              <Button
                type="primary"
                data-test-selector={"btnAddRow"}
                onClick={onAddRowPress}
                className="text-uppercase"
              >
                {translate("quickAdd.btnAddRow")}
              </Button>
            </Space>
          </>
        </Col>
        <Col className="gutter-row right-action-col" span={8} xs={24} sm={24} md={8} lg={8} xl={8}>
          <Space size={"middle"} direction="vertical" className="d-flex">
            <Title className="m-0 text-uppercase quick-add-sub-title">SKU List</Title>
            <TextArea
              rows={4}
              placeholder={
                "Copy and paste skus here \n\n SKU Only \n SKU + Quantity (comma-separated) "
              }
              style={{ resize: "none" }}
              value={skuList}
              onChange={addSkuList}
            />
            <Space className="d-flex justify-end">
              <Button
                type="primary"
                size={"middle"}
                className="text-uppercase"
                disabled={isAllValidate || !skuList}
                onClick={addProductToQuickList}
              >
                {translate("quickAdd.btnAddAllToQuickList")}
              </Button>
            </Space>
          </Space>
          <Divider />
          <Space size={5} direction="vertical" className="d-flex">
            <Title className="m-0 text-uppercase quick-add-sub-title">
              {translate("quickAdd.titleUploadYourSpreadsheet")}
            </Title>
            <Text type="secondary" className="csv-sub-title">
              {translate("quickAdd.titleSelectCsvXlsx")}
            </Text>
            <Space align="center">
              <Input style={{ width: 212 }} />
              <Upload {...fileUploadprops} accept=".csv,.xls,.xlsx" customRequest={customRequest}>
                <Button type="primary" className="text-uppercase">
                  {translate("quickAdd.btnBrowse")}
                </Button>
              </Upload>
            </Space>
          </Space>
          <Divider />
          <Space direction="vertical" className="d-flex ">
            <Title className="m-0 text-uppercase quick-add-sub-title">
              {translate("quickAdd.titleGuide")}
            </Title>
            <Space className="template-box">
              <FileTextOutlined className="file-icon" />
              <Space direction="vertical" size={5}>
                <Text>{translate("quickAdd.titleDownloadSpreadsheet")}</Text>
                <Space direction="horizontal">
                  <a
                    className="file-type-text cursor-pointer"
                    onClick={() => downloadQuickOrderTemplate(".csv")}
                  >
                    {translate("quickAdd.titleCsv")}
                  </a>
                  {/* <a
                    className="file-type-text cursor-pointer"
                    onClick={() => downloadQuickOrderTemplate("xlsx")}
                  >
                    {translate("quickAdd.titleXlsx")}
                  </a> */}
                </Space>
              </Space>
            </Space>
            <Text type="secondary" className="csv-sub-title">
              {translate("quickAdd.informationMessage")}
            </Text>
          </Space>
        </Col>
      </Row>
      <Divider />
      <div className="popup-action mt-24">
        <Space>
          <Button
            size={"middle"}
            onClick={() => {
              onClear();
              setOpen(false);
              setSkuList("");
            }}
          >
            {translate("quickAdd.btnCancel")}
          </Button>
          <Button
            type="primary"
            size={"middle"}
            disabled={isAllValidate || !skuValue}
            onClick={() => {
              addProductsToQuickOrder();
              getOrderDetailsSKU();
            }}
          >
            {translate("quickAdd.btnAddToOrder")}
          </Button>
        </Space>
      </div>
      <Loader loading={loader.quickOrderProductsLoading} />;
    </ModalComponent>
  );
};
export default QuickAddModal;
