import React from "react";
import { Select, Space } from "antd";
import { SelectInputProps } from "interfaces/ClientInterface/ISelect";
import "./Select.scss";

export const SelectInput: React.FC<SelectInputProps> = ({
  defaultValue,
  onChange,
  disabled,
  loading,
  placeholder,
  allowClear,
  options,
  showSearch,
  optionMenuPlacement,
  size,
  className,
  style,
  dropdownStyle,
  bordered,
  dataTestSelector,
  value,
  fieldNames,
}: SelectInputProps) => {
  return (
    <Space wrap>
      <Select
        placeholder={placeholder}
        value={value}
        className={className}
        size={size || "middle"}
        disabled={disabled}
        defaultValue={defaultValue}
        onChange={onChange}
        placement={optionMenuPlacement || "bottomLeft"}
        loading={loading}
        allowClear={allowClear}
        options={options}
        bordered={bordered}
        showSearch={showSearch}
        style={style}
        dropdownStyle={dropdownStyle}
        onClick={(e) => {
          e.stopPropagation();
          e.nativeEvent.stopImmediatePropagation();
        }}
        data-test-selector={dataTestSelector}
        fieldNames={fieldNames}
      />
    </Space>
  );
};

export default SelectInput;
