/* eslint-disable no-unused-vars */
/* eslint-disable @typescript-eslint/no-unused-vars */
/* eslint-disable max-lines */
/* eslint-disable max-lines-per-function */
/* eslint-disable max-lines */
/* eslint-disable max-len */
/* eslint-disable indent */
import React, { useContext, useEffect, useState } from "react";
import { Card, Col, Collapse, Row, Space, Typography, notification } from "antd";
import ProductDescription from "components/Common/Product/ProductDescription";
import ProductImage from "components/Common/Product/ProductImage";
import ProductSku from "components/Common/Product/ProductSku";
import ProductTitle from "components/Common/Product/ProductTitle";
import ProductPrice from "components/Common/Product/ProductPrice";
import ProductQuantity from "components/Common/Product/Quantity";
import ProductTier from "components/Common/Product/ProductTier";
import ShippingInfo from "./ShippingInformation";
//import ProductConfiguration from "./ProductConfiguration";
import { useNavigate, useParams } from "react-router-dom";
import {
  IAddProductProp,
  IOrderEditProduct,
  IProductDetailsProp,
  IProductVariant,
  IConfigurableAttributeList,
  IProductAttribute,
  ICustomAttribute,
  IOrderProduct,
  IOrderProductDetails,
  IParentOrderProductAttributeValue,
} from "interfaces/APIInterface/IProducts";
import {
  ATTRIBUTE_CODE_SHORT_DESCRIPTION,
  GET_ORDER_DETAILS_FAILED,
  GET_ORDER_STATUS_FAILED,
  GET_PRODUCT_FLAGS_FAILED,
  getPriceRowColumns,
  getQuantityRowColumns,
  getAttributeValue,
  getConfigurableAttributeVariantDetails,
  ADD_FLAG_SUCCESS,
  ADD_FLAG_FAILED,
  UPDATE_PRODUCT_FAILED,
  UPDATE_PRODUCT_SUCCESS,
  getConfigurableAttributeValues,
  getAttributeValueForVariants,
  getCustomAttributeValueForVariants,
  NAConfigurableAttributePrice,
  CheckNAAttributeValue,
} from "components/Common/Product/Product.Constant";
import {
  IConfigurableProductRequestModel,
  IRowPriceColumnItem,
  IRowQuantityColumnItem,
  ISelectedVariant,
} from "interfaces/ClientInterface/IProducts";
import {
  addProduct,
  getProductDetails,
  getProductDetailsForEdit,
} from "api/services/addProduct.api";
import { notificationController } from "components/Common/Notification/Notification";
import { Znode_NA_Code, THUMBNAIL_IMAGE_PATH, TOP_PLACEMENT } from "config/constant";
import {
  addOrderFlag,
  getOrder,
  getOrderStatus,
  unAssociatedOrderFlagList,
  getOrderStatusById,
  validateOrderLineItems,
} from "api/services/editOrder.api";
import { IOrder, IOrderStatus, OrderStatusListProps } from "interfaces/ClientInterface/IEditOrder";
import CollapseComponent from "components/Common/Collapse/Collapse";
import ProductFlagsHeader from "./ProductFlags/ProductFlagsHeader";
import ModalComponent from "components/Common/Modal/Modal";
import { ProductFlagsList } from "./ProductFlags/ProductFlagsList";
import { IUnAssociatedProductFlag } from "interfaces/ClientInterface/IProductFlag";
import ProductFlagsContent from "./ProductFlags/ProductFlagsContent";
import { IAddUpdateOrderFlag, IOrderFlag } from "interfaces/ClientInterface/IOrderFlag";
import { readUserId } from "api/services/localStorage.service";
import { ROUTES_PATH } from "routes/Routes.Constant";
import EditProductHeader from "./EditProductHeader";
import { translate } from "i18n";
import { AbilityContext } from "ability/can";
import StatusDropdown from "components/Common/Status/StatusDropdown";
import "./EditProduct.scss";
import { getGlobalSetting } from "api/services/localStorage.service";
import Variants from "components/Common/Product/AddOn/Variants";
import { PERMISSION_CODE, PERMISSION_SUBJECT } from "ability/utils";
import { InfoCircleOutlined } from "@ant-design/icons";
import { parse } from "path";
import ProductDetail from "components/Common/Product/ProductDetail";

const { Panel } = Collapse;
const { Text } = Typography;

const EditProduct = () => {
  const ability = useContext(AbilityContext);
  const canChangeOrderLineStatus = ability.can(
    PERMISSION_CODE.CHANGE_ORDER_LINE_STATUS,
    PERMISSION_SUBJECT.ORDERS
  );
  const [orderStateName, setProductStatus] = useState<string>("");
  const [productStateId, setProductStateId] = useState({} as number);
  const [quantity, setQuantity] = useState({} as number | null);
  const { orderProductId, childSKU } = useParams<Record<string, string | undefined>>();
  const [product, setProduct] = useState({} as IProductDetailsProp);
  const [selectedVariant, setSelectedVariant] = useState({} as ISelectedVariant);
  const [order, setOrder] = useState({} as IOrder);
  const [orderStatusList, setOrderStatusList] = useState<OrderStatusListProps[]>([]);
  const [isModalVisible, setIsModalVisible] = useState(false as boolean);
  const [selectedRowKeys, setSelectedRowKeys] = useState<React.Key[]>([]);
  const [productFlags, setProductFlags] = useState<IOrderFlag[]>([]);
  const [productNote, setProductNote] = useState<string>("");
  const [orderProductData, setOrderProductData] = useState({} as IOrderEditProduct);
  const navigate = useNavigate();
  const [searchInput, setSearchInput] = useState("");
  const [unAssociatedProductFlags, setUnAssociatedProductFlags] = useState<
    IUnAssociatedProductFlag[]
  >([]);
  const [configurableProductModel, setConfigurableProductModel] = useState(
    {} as IConfigurableProductRequestModel
  );
  const [editQuantity, setEditQuantity] = useState({} as number | null );
  const globalSettings = getGlobalSetting() ? JSON.parse(getGlobalSetting() || "") : {};
  const priceRoundOff = globalSettings?.PriceRoundOff;
  const [variant, setVariant] = useState<string[]>([]);
  const [selectCustomAttribute ,setCustomatrribute] = useState<ICustomAttribute[]>([]);
  const [selectOrderProduct ,setOrderProduct] = useState<IOrderProduct>();
  const [showStock,setshowStock]=useState(false);
  const [ParentProductImage, setParentProductImage] = useState<string>("");

  

  useEffect(() => {
    fetchEditProductDetails();
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, []);

  /**
   * This function is used to navigate to the edit order page.
   */
  const backToEditOrder = () => {
    navigate(`/${ROUTES_PATH.EDIT_ORDER}/${order?.OrderId}`);
  };

  /**
   * This function is used for getting the order details for summary
   * and product details for edit mode along with product status list
   */
  const fetchEditProductDetails = async () => {
    //This function is used for getting the product's order details
    const orderProductDetails: IOrderEditProduct = await fetchOrderProductDetails();
  
    const parseData = JSON.parse(orderProductDetails?.ProductDetails);
    const orderProductDetailsJson: IOrderProductDetails[] = parseData;
    const orderProductDetailsCurrent: IOrderProduct =
      // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
      orderProductDetailsJson[0].OrderProduct.find(
        (x) =>
          x.OrderProductId.toUpperCase() == orderProductDetails?.OrderProductId.toUpperCase()
      )!;
     
      const customAttribute:ICustomAttribute[]=[];
      orderProductDetailsCurrent.OrderProductAttributeValue?.forEach((cAttribute) => {
      const customattirbute:ICustomAttribute={
        AttributeCode:cAttribute.AttributeCode,
        AttributeValues:cAttribute.AttributeValue      
      };
      customAttribute.push(customattirbute);
      });
    setCustomatrribute(customAttribute);

    setOrderProduct(orderProductDetailsCurrent);
    //This function is used to get the order summary details
    getOrderDetails(orderProductDetails?.OrderId);

    //This function is used to get the order status list
    getOrderStatusList();
    

     let productId=0;
     let IsProductNa=false;
    IsProductNa = CheckNAAttributeValue(IsProductNa, customAttribute);
    if (!IsProductNa) 
    {
      const  parentDetails =  orderProductDetailsCurrent?.ParentOrderProductAttributeValue?.find((el: IParentOrderProductAttributeValue) => {
        return el?.AttributeCode == "ParentProductId";
      });
      productId = Number(parentDetails?.AttributeValue);
    }
     else{
      productId =
        orderProductDetails.ParentPublishProductId === 0
          ? orderProductDetails.PublishProductId
          : orderProductDetails.ParentPublishProductId;
      }
  
    //This function is used to get the specific product details (PDP)
    const customattirbutesData: ICustomAttribute[] = [];
    getProductDetails(
      productId,
      
      orderProductDetails.ZnodeCatalogId,
      orderProductDetails.LocaleId,
      orderProductDetails.PortalId,
      childSKU
    )
    // eslint-disable-next-line no-console
      .then((productResponse) => {
        const productDetails: IProductDetailsProp = productResponse.PublishProduct;
        setParentProductImage(productDetails.ParentProductImageSmallPath);

        const Price =
          productDetails?.SalesPrice == null
            ? productDetails?.RetailPrice
            : productDetails?.SalesPrice;
        let productPrice = typeof Price === "number" ? Price?.toFixed(priceRoundOff) : Price;
        const customattribute: ICustomAttribute[] = [...selectCustomAttribute];
        
        // eslint-disable-next-line prefer-const

        const NAConfigurableData =  NAConfigurableAttributePrice(customAttribute, productPrice);
        const isProductNa =NAConfigurableData.isProductNa;
        setshowStock(isProductNa);
        productPrice=NAConfigurableData.productPrice;
        

        const formattedPriceTiers =
          productDetails && productDetails?.TierPriceList?.length > 0
            ? productDetails?.TierPriceList?.map((tier) => ({
                ...tier,
                Price:
                  typeof tier.Price === "number"
                    ? parseFloat(tier?.Price).toFixed(priceRoundOff)
                    : tier?.Price,
              }))
            : [];
                        
        productDetails.ConfigurableProductSKU = orderProductDetails?.ParentPublishProductId == 0
            ? productDetails?.SKU
              : productDetails?.ConfigurableProductSKU; 

          productDetails.Name = orderProductDetails?.ParentPublishProductId == 0
            ? productDetails?.ParentConfiguarableProductName
            : productDetails?.Name ;                
        setProduct({ ...productDetails, Price: productPrice, TierPriceList: formattedPriceTiers});
      
        const attributeCodeVariant: string[] = getConfigurableAttributeValues(
          productDetails.Attributes
        );
        setVariant(attributeCodeVariant);
        const defaultSelectedVariant: string[] = getAttributeValueForVariants(
          productDetails.Attributes,
          attributeCodeVariant
        );
        // eslint-disable-next-line no-console       
        const defaultSelectedCustomVariant: string[] = getCustomAttributeValueForVariants(
          orderProductDetailsCurrent?.OrderProductAttributeValue??[],
          attributeCodeVariant
        );
        
       

        setSelectedVariant((prevState: ISelectedVariant) => ({
          ...prevState,
          defaultVariant: defaultSelectedCustomVariant==null ? defaultSelectedVariant: defaultSelectedCustomVariant,
        }));

        setConfigurableProductDetailsModel(
          orderProductDetails?.LocaleId,
          orderProductDetails?.ParentPublishProductId == 0
            ? orderProductDetails?.PublishProductId
            : orderProductDetails?.ParentPublishProductId,
          productDetails?.SKU,
          orderProductDetails?.PortalId,
          orderProductDetails?.ZnodeCatalogId,
            productDetails?.ConfigurableProductSKU ,
            productDetails.ParentConfiguarableProductName       
        );
        
        
      })
      .catch((err) => {
        notificationController.error({ message: err.message, placement: TOP_PLACEMENT });
      });
  };

  /**
   * This function is used for getting the product's order details
   */
  const fetchOrderProductDetails = async () => {
    return await getProductDetailsForEdit(orderProductId)
      .then((response) => {
        const orderProductDetails: IOrderEditProduct = response.Product;      
      
       
        setProductStatus(orderProductDetails?.OrderStateName);
        setProductStateId(orderProductDetails?.OmsOrderStateId);
        const orderProductFlags = JSON.parse(orderProductDetails?.ProductFlags);
        getAndSetProductFlags(orderProductFlags);
        setQuantity(editQuantity && editQuantity > 1 ? editQuantity : orderProductDetails?.Quantity);
        setProductNote(orderProductDetails?.ProductNote ?? "");    
        setOrderProductData(orderProductDetails);
        return response.Product;
      })
      .catch((err) => {
        notificationController.error({ message: err.message, placement: TOP_PLACEMENT });
      });
  };

  /**
   * This function is used to get the order summary details
   */
  const getOrderDetails = (orderId: string | undefined) => {
    getOrder(orderId)
      .then((response) => {
        const orderData: IOrder = response?.Order;
        setOrder(orderData);
      })
      .catch(() => {
        notificationController.error({ message: GET_ORDER_DETAILS_FAILED });
      });
  };

  /**
   * This function is used to get the order status list
   */
  const getOrderStatusList = () => {
    getOrderStatus()
      .then((response) => {
        const orderStatusListData: OrderStatusListProps[] = response?.StatusList;
        setOrderStatusList(orderStatusListData);
      })
      .catch(() => {
        notificationController.error({ message: GET_ORDER_STATUS_FAILED });
      });
  };

  const productVariants: IConfigurableAttributeList[] = getConfigurableAttributeVariantDetails(
    product && product.Attributes,
    variant
  );

  const productQuantityTierColumn: IRowQuantityColumnItem[] = getQuantityRowColumns(
    product && product.TierPriceList
  );

  const productPriceTierColumn: IRowPriceColumnItem = getPriceRowColumns(
    product && product.TierPriceList,
    product && product.CurrencySuffix
  );

  /**
   * This function is called to open the flag association to product pop-up
   */
  const openProductFlagsModal = () => {
    if (unAssociatedProductFlags?.length <= 0) {
      getUnAssociatedProductFlags(true);
    } else {
      setIsModalVisible(true);
    }
  };

  /**
   * This function is used to get the product un-associated flags
   */
  const getUnAssociatedProductFlags = (isOpen = false) => {
    if (orderProductId) {
      unAssociatedOrderFlagList(orderProductId)
        .then((response) => {
          setUnAssociatedProductFlags(response?.OrderFlags);
          if (isOpen) {
            setIsModalVisible(true);
          }
        })
        .catch(() => {
          notificationController.error({ message: GET_PRODUCT_FLAGS_FAILED });
        });
    }
  };

  /**
   * This function is used to get and set the product associated flags
   */
  const getAndSetProductFlags = (productFlagList: IOrderFlag[]) => {
    const filteredProductFlagList = [
      ...productFlagList.filter((item) => !item.IsActiveOverridden),
      ...productFlagList.filter((item) => item.IsActiveOverridden),
    ];
    filteredProductFlagList.sort((a, b) => (a.DisplayOrder > b.DisplayOrder ? 1 : -1));

    setProductFlags(filteredProductFlagList);
  };

  /**
   * This function is used to add the flags to the product
   */
  const handleAddProductFlags = async () => {
    const flagId: string = selectedRowKeys?.join(",");
    const addProductFlagPayload: IAddUpdateOrderFlag = {
      OrderId: orderProductId,
      UserId: readUserId(),
      CPOrderFlagId: flagId,
      OrderTypeCode: order?.OrderType,
    };

    await addOrderFlag(addProductFlagPayload)
      .then(() => {
        setIsModalVisible(false);
        setSearchInput("");
        fetchOrderProductDetails();
        notificationController.success({ message: ADD_FLAG_SUCCESS });
      })
      .catch(() => {
        setIsModalVisible(false);
        notificationController.error({ message: ADD_FLAG_FAILED });
      });

    getUnAssociatedProductFlags(false);
    setSelectedRowKeys([]);
  };

  /**
   * This function is used when the order product needs to be updated.
   */
  const onUpdateOrderProduct = (isSaveAndClose: boolean) => {
    const customeProductAttribute : ICustomAttribute[]=[];
    let IsProductNa=false;
    if(selectCustomAttribute.length>0){
      IsProductNa = CheckNAAttributeValue(IsProductNa, selectCustomAttribute);
    }
    const productVariant: IProductVariant = {
        ZnodeProductId:
            !IsProductNa
        ? product.PublishProductId
        : product.ConfigurableProductId,
      GroupingCode: "",
      IsAddOn: false,
      ParentDetail: "",
      Customization: "",
      Quantity: quantity,
      Price: product?.Price,
      ProductNote: productNote,
      Attributes: product?.Attributes,
      NAAttribute:  !IsProductNa ? customeProductAttribute : selectCustomAttribute,
    ParentProductId:configurableProductModel?.parentProductId,  
    };

    const productModel: IAddProductProp = {
      OrderId: order?.OrderId,
      VersionId: orderProductData?.VersionId,
      ProductVariantDetails: [productVariant],
      UserId: readUserId(),
      OrderProductId: orderProductData?.OrderProductId,
      OmsOrderStateId: productStateId,
      SKU: product.SKU,
      ConfigurableProductSKU: product.ConfigurableProductSKU,
    };

    addProduct(productModel)
      .then((response) => {
        if (response.StatusModel && response.StatusModel.Status) {
          notificationController.success({
            message: UPDATE_PRODUCT_SUCCESS,
            placement: TOP_PLACEMENT,
          });

          if (isSaveAndClose) {
            backToEditOrder();
          }
        } else {
          notificationController.error({
            message: UPDATE_PRODUCT_FAILED,
            placement: TOP_PLACEMENT,
          });
        }
      })
      .catch(() => {
        notificationController.error({ message: UPDATE_PRODUCT_FAILED, placement: TOP_PLACEMENT });
      });
  };

  /**
   * This function is called when the status is changed from the dropdown
   */
  /**
 * This function is called when the status is changed from the dropdown
 */
const onProductStatusChange = async (selectedText: string, productStatusObj: IOrder) => {
    const result = await handleLineItemsValidationOnStatusChange(
      productStatusObj.OmsOrderStateId,
      order?.OrderId,
      orderProductId ?? ""
    );
    if (
      result.length === 0 ||
      result?.[0] == "TriggerFinalizedDate" ||
      result?.[0] == "ValidationNotFound" ||
      result?.[0] == "SetOrderLineItem" ||
      result?.[0] == "SetOrderAndFinalized" ||
      (result?.[0] == "SetOrderCompletenessAndFinalized" && result?.[1].length === 0) ||
      (result?.[0] == "SetOrderAndCompleteness" && result?.[1].length === 0) ||
      (result?.[0] == "CompletenessAndFinalized" && result?.[1].length === 0)
    ) {
          setProductStatus(productStatusObj.OrderStateName);
          setProductStateId(productStatusObj.OmsOrderStateId);
    } else {
      showValidationMessages(result.length > 1 ? result?.[1] : result);
    }
};

  /**
   * This function is used to set the ConfigurableProductModel which will be passed to API
   * to get the configurable product details
   */
  const setConfigurableProductDetailsModel = (
    localeId: number,
    parentProductId: number,
    parentProductSKU: string,
    portalId: number,
    publishCatalogId: number,
    childSku: string,
    parentConfiguarableProductName :string
  ) => {
    const configurableProductModelDetails: IConfigurableProductRequestModel = {
      localeId: localeId,
      parentProductId: parentProductId,
      parentProductSKU: parentProductSKU,
      portalId: portalId,
      publishCatalogId: publishCatalogId,
      sku: childSku,
      ParentProductName :parentConfiguarableProductName
     
    };

    setConfigurableProductModel(configurableProductModelDetails);
  };

 const getImageUrl = () => {          
  if(product.ImageThumbNailPath !="" )
  {
    return product.ImageThumbNailPath;
  }else{
    const imageData = product?.Attributes?.find((el: IProductAttribute) => {
      return el?.AttributeCode == "ProductImage";
    });
    return THUMBNAIL_IMAGE_PATH + imageData?.AttributeValues;
  }
    };

  const handleLineItemsValidationOnStatusChange = async (
    omsOrderStateId: number,
    orderId: string,
    orderProductId: string
  ) => {
    const response = await getOrderStatusById(omsOrderStateId);
    const statusDetail: IOrderStatus = response?.OrderStatusDetail;
  
    if (statusDetail?.IsCPRequireCompleteness && statusDetail?.IsOrderLineItemState) {
      const validationDetails = await onValidateOrderLineItems(orderId, orderProductId);
      return ["SetOrderAndCompleteness", validationDetails];
    } else if (statusDetail?.IsCPRequireCompleteness) {
      return await onValidateOrderLineItems(orderId, orderProductId);
    } else if (statusDetail?.IsOrderLineItemState) {
      return ["SetOrderLineItem"];
    } else {
      return ["ValidationNotFound"];
    }
  };
  
  const onValidateOrderLineItems = (orderId: string, orderProductId: string) => {
    return validateOrderLineItems(orderId, orderProductId)
      .then(async (response) => {
        return response?.ValidationMessages;
      })
      .catch(() => {
        notificationController.error({
          message: translate("editOrder.failedToGetValidationDetailsMessage"),
        });
      });
  };
  const showValidationMessages = (result: string[]) => {
    notificationController.error({
      message: (
        <Space direction="vertical" size={1}>
          {result.map((item: string, i: number) => {
            return (
              <div key={i} className="validation-msg">
                <InfoCircleOutlined
                  style={{ marginRight: "8px" }}
                  onClick={() => notification.destroy()}
                />
                {item}
              </div>
            );
          })}
        </Space>
      ),
      placement: "topRight",
      className: "top-120 notification-without-description error-notification",
      duration: 0,
    });
  };
  return (
    <>
      <Space direction="vertical" size={"middle"} className="d-flex">
        <EditProductHeader orderSummary={order} onUpdateOrderProduct={onUpdateOrderProduct} />
        <Card className="product-details-container">
          <Row className="product-details-row" gutter={16}>
            <Col className="gutter-row first-col" span={7}>
              <Row gutter={[15, 30]}>
                <Col span={6}>
                  <ProductImage
                    imageUrl={getImageUrl()}
                    imageHeight="100%"
                    imageWidth="auto"
                    isPreview={false}
                    className="product-image"
                    alt={translate("editProduct.altProductImage")}
                  />
                </Col>
                <Col span={18}>
                  <Space direction="vertical" size={5} className="d-flex">
                    <ProductTitle
                      titleClass="product-name m-0"
                      titleText={product && product.Name}
                      textFontLevel={5}
                    />
                    <ProductSku
                      labelClass="product-sku text-color"
                      productSku={
                        product &&
                        (product.IsConfigurableProduct
                          ? product.ConfigurableProductSKU
                          : product.SKU)
                      }
                    />
                    <ProductDescription
                      descClass="product-desc text-color"
                      descriptionData={getAttributeValue(
                        product && product.Attributes,
                        ATTRIBUTE_CODE_SHORT_DESCRIPTION
                      )}
                    />
                  </Space>
                </Col>
                {productVariants && productVariants?.length > 0 ? (
                  <Col span={24}>
                    <Collapse size="small" defaultActiveKey={"1"}>
                      <Panel
                        header={`Product Variants: ${
                          Array.isArray(selectedVariant?.defaultVariant) &&
                          selectedVariant?.defaultVariant?.length > 0
                            ? selectedVariant?.defaultVariant
                                .map((item) => item?.toString())
                                .join(", ")
                            : selectedVariant?.defaultVariant instanceof Object &&
                              Object.values(selectedVariant.defaultVariant).length > 0
                            ? Object.values(selectedVariant.defaultVariant)
                                .map((item) => item?.toString())
                                .join(", ")
                            : "No variants selected"
                        }`}
                        key="1"
                      >
                        <Space direction="vertical" size={5} className="d-flex">
                          {variant && variant?.length > 0
                            ? variant.map((item, index: number) => (
                                <Variants
                                  key={index}
                                  configurableAttributes={
                                    productVariants[index]?.ConfigurableAttributeList
                                  }
                                  setProduct={setProduct}
                                  selectedVariant={selectedVariant}
                                  setSelectedVariant={setSelectedVariant}
                                  configurableProductModel={configurableProductModel}
                                  variant={variant}
                                  index={index}
                                  selectCustomAttribute={selectCustomAttribute}
                                   setCustomatrribute ={setCustomatrribute}
                                   setshowStock={setshowStock}  
                                   ParentProductImage={ ParentProductImage}
                                />
                              ))
                            : null}
                        </Space>
                      </Panel>
                    </Collapse>
                  </Col>
                ) : null}
              </Row>
            </Col>
            <Col className="gutter-row middle-col" span={9}>
              <Space direction="vertical" size={"large"} className="d-flex">
                <Space size={15}>
                  <ProductPrice
                    priceClass="product-price  m-0"
                    priceFontLevel={3}
                    price={product && product.Price}
                    currency={product && product.CurrencySuffix}
                    inStockQuantity={product && product.Quantity} 
                    IsNAAttributeAvailable={false} 
                    showStock={showStock}               />
                  <ProductQuantity
                    quantity={quantity}
                    setQuantity={setQuantity}
                    editQuantity={editQuantity}
                    setEditQuantity={setEditQuantity}
                    spaceDirection={"vertical"}
                  />
                </Space>
                {productQuantityTierColumn?.length > 1 ? (
                  <ProductTier
                    productQuantityTierColumn={productQuantityTierColumn}
                    productPriceTierColumn={productPriceTierColumn}
                  />
                ) : null}
                <div className="collapse-container">
                  <CollapseComponent
                    size="small"
                    title={<ProductFlagsHeader openProductFlagsModal={openProductFlagsModal} />}
                    dataTestSelector="collapseProductFlags"
                  >
                    <ProductFlagsContent
                      productFlags={productFlags}
                      getUnAssociatedProductFlags={getUnAssociatedProductFlags}
                      fetchOrderProductDetails={fetchOrderProductDetails}
                    />
                  </CollapseComponent>
                </div>
              </Space>
            </Col>
            <Col className="gutter-row last-col" span={8}>
              <Space direction="vertical" size={"large"} className="d-flex config-status-space">
                <div className="section-item-content">
                  <Row>
                    <Col span={6} className="d-flex align-center">
                      <Text className="text-color inp-label">
                        <strong>{translate("editProduct.productStatusTitle")}:</strong>
                      </Text>
                    </Col>
                    <Col span={18}>
                      <StatusDropdown
                        orderStatusList={orderStatusList}
                        size="middle"
                        value={orderStateName || undefined}
                        placeholder="Select"
                        bordered={false}
                        data-test-selector={"drpStatus"}
                        onChange={(selectedText: string, option: IOrder) =>
                          onProductStatusChange(selectedText, option)
                        }
                        disabled={!canChangeOrderLineStatus}
                        selectedValueKey={"OrderStateName"}
                      />
                    </Col>
                  </Row>
                </div>
                {/* <div className="section-item-content">
                  <ProductConfiguration
                    productStatus="Failed"
                    errorText={translate("editProduct.productConfigErrorMessage")}
                  />
                </div> */}
                <div className="section-item-content">
                  <ShippingInfo productNote={productNote} setProductNote={setProductNote} />
                </div>
              </Space>
            </Col>
          </Row>
        </Card>
      </Space>
      <ModalComponent
        title={translate("editProduct.addProductFlagTitle")}
        visible={isModalVisible}
        onOK={() => {
          if (selectedRowKeys && selectedRowKeys?.length) {
            handleAddProductFlags();
          }
        }}
        onCancel={() => {
          setIsModalVisible(false);
          setSelectedRowKeys([]);
          setSearchInput("");
        }}
        cancelText={translate("editProduct.cancelBtn")}
        okText={translate("editProduct.btnAdd")}
        bodyStyle={{
          overflowY: "hidden",
          minHeight: "300px",
        }}
        dataTestSelector="popAddProductFlags"
        zIndex={10}
        isMaskClosable={false}
        className="pop-add-product-flags standard-modal"
        modalWidth="450px"
      >
        <ProductFlagsList
          unAssociatedProductFlags={unAssociatedProductFlags}
          selectedRowKeys={selectedRowKeys}
          setSelectedRowKeys={setSelectedRowKeys}
          setSearchInput={setSearchInput}
          searchInput={searchInput}
        />
      </ModalComponent>
    </>
  );
};

export default EditProduct;
