import React from "react";
import { Alert, Col, Row, Typography } from "antd";
import { ExclamationCircleTwoTone } from "@ant-design/icons";
import { IProductStatus } from "interfaces/ClientInterface/IProducts";
import { translate } from "i18n";

const { Text } = Typography;

const ProductConfiguration = (props: IProductStatus) => {
  const { productStatus, errorText } = props;
  return (
    <Row gutter={[50, 15]} className="product-config-container">
      <Col span={16} className="d-flex align-center">
        <Text className="text-color inp-label">
          <strong>{translate("editProduct.productConfigLabel")}:</strong>
        </Text>
      </Col>
      <Col span={8} className="config-status">
        <ExclamationCircleTwoTone twoToneColor="#FF4D4F" />{" "}
        <Text className="config-status-text">{productStatus}</Text>
      </Col>
      <Col span={24}>
        <Alert
          message={
            <>
              <ExclamationCircleTwoTone twoToneColor="#FF4D4F" />{" "}
              <Text className="error-text">{errorText}</Text>
            </>
          }
          type="error"
          closable
        />
      </Col>
    </Row>
  );
};

export default ProductConfiguration;
