import React from "react";
import { Col, Row, Space, Button } from "antd";
import { Typography } from "antd";
import { PlusOutlined } from "@ant-design/icons";
import { IProductFlagsHeaderProps } from "interfaces/ClientInterface/IProductFlag";
import { translate } from "i18n";
const { Text } = Typography;

/**
 * @returns This React functional component returns a JSX element that renders a
 * product flags and button to add flags
 */
export default function ProductFlagsHeader({ openProductFlagsModal }: IProductFlagsHeaderProps) {
  return (
    <Row justify={"space-evenly"}>
      <Col>
        <Space split={"|"} size={20} align="center">
          <Text className="m-0 accordion-heading">
            {" "}
            {translate("editProduct.productFlagsLabel")}
          </Text>
          <Button
            size="small"
            type="primary"
            icon={<PlusOutlined />}
            data-test-selector="btnAddProductFlag"
            onClick={(e) => {
              openProductFlagsModal && openProductFlagsModal();
              e.stopPropagation();
              e.nativeEvent.stopImmediatePropagation();
            }}
          >
            {translate("editProduct.addFlagBtn")}
          </Button>
        </Space>
      </Col>
    </Row>
  );
}
