import React, { ChangeEvent, ChangeEventHandler } from "react";
import { Col, Row, Typography, Input } from "antd";
import { ADD_NOTES_HERE_PLACEHOLDER } from "components/Common/Product/Product.Constant";
import { IProductNoteProp } from "interfaces/ClientInterface/IProducts";
import { translate } from "i18n";

const { Text } = Typography;
const { TextArea } = Input;

const ShippingInfo: React.FC<IProductNoteProp> = ({
  productNote,
  setProductNote,
}: IProductNoteProp) => {
  const onProductNoteChange: ChangeEventHandler = (event: ChangeEvent<HTMLInputElement>) => {
    setProductNote(event.target.value);
  };

  return (
    <Row gutter={[15, 30]} className="">
      <Col span={24}>
        <Row>
          <Col span={6} className="d-flex align-start">
            <Text className="text-color inp-label">
              <strong>{translate("editProduct.itemNoteLabel")}:</strong>
            </Text>
          </Col>
          <Col span={18}>
            <TextArea
              rows={4}
              placeholder={ADD_NOTES_HERE_PLACEHOLDER}
              value={productNote}
              onChange={onProductNoteChange}
            />
          </Col>
        </Row>
      </Col>
    </Row>
  );
};

export default ShippingInfo;
