/* eslint-disable react/react-in-jsx-scope */
/* eslint-disable max-len */
/* eslint-disable max-lines-per-function */
import { Button, Input, Select, Space } from "antd";
import { CloseCircleOutlined } from "@ant-design/icons";
import {
  FiltersProps,
  IFilterItemProps,
  IFilterTypes,
} from "interfaces/ClientInterface/IOrderList";
import { initialFilterColumnList, subFilterMenu, subFilterMenuForTotal } from "./Order.Constant";
import { IColumnProps } from "interfaces/ClientInterface/IEditOrder";
import { SetStateAction } from "react";
import { notificationController } from "components/Common/Notification/Notification";
import { translate } from "i18n";
import { removeLocalStorageData, setLocalStorageDataForFilters } from "utils/localStorage";
import { FILTERVALUE, ORDERTYPE, STORELIST } from "config/constant";

let filteredColumns = [];
let FiltersList: IFilterTypes[];
let filterColumnsList: SetStateAction<IColumnProps[]> = [];
export const Filters: React.FC<FiltersProps> = ({
  setOpenFilter,
  manageFilter,
  filterValue,
  setFilterValue,
  setOrderListParams,
  setAppliedFilters,
  appliedFilters,
  filterColumnListData,
  setFilterColumnListData,
  isFilterClear,
}: // clickedAppliedFilter,
FiltersProps) => {
  const closePopOver = () => {
    const filterColumnData = initialFilterColumnList();
    setFilterColumnListData(filterColumnData);
    setOpenFilter(false);
    if (isFilterClear) {
      setFilterValue([]);
      setFilterValue((prevState) => {
        const filterData: IFilterItemProps[] = [...prevState];
        filterData.push({
          FilterName: "",
          FilterOperator: "",
          FilterValue: "",
        });
        return filterData;
      });
    } else {
      setAppliedFilters((prevState) => {
        const filterData: IFilterItemProps[] = [...prevState];
        return filterData;
      });
      setFilterValue(appliedFilters);
    }
  };

  const onChangeHandler = (text: string, field: string, index: number) => {
    setFilterValue((prevState) => {
      const filterData: IFilterItemProps[] = [...prevState];
      const row: IFilterItemProps = filterData[index];
      row[field as keyof IFilterItemProps] = text;
      if (text === "Total") {
        row.FilterOperator = "Equals";
        FiltersList = subFilterMenuForTotal;
      } else {
        row.FilterOperator = "Contains";
        FiltersList = subFilterMenu;
      }
      filterData[index] = row;
      return filterData;
    });
  };
  const onChangeFilterHandler = (text: string, field: string, index: number) => {
    setFilterValue((prevState) => {
      const filterData: IFilterItemProps[] = [...prevState];
      const row: IFilterItemProps = filterData[index];
      row[field as keyof IFilterItemProps] = text;
      filterData[index] = row;
      return filterData;
    });
  };

  const onAddFilterPress = () => {
    setFilterValue((prevState) => {
      const filterData: IFilterItemProps[] = [...prevState];
      filteredColumns = filterColumnListData;
      filterColumnsList = [];
      if (filterData.length > 0) {
        for (let filterCol = 0; filterCol < filterData.length; filterCol++) {
          setFilterColumnListData([]);
          filterColumnsList = [];
          for (
            let filterColDropdown = 0;
            filterColDropdown < filteredColumns.length;
            filterColDropdown++
          ) {
            if (filteredColumns[filterColDropdown].key !== filterData[filterCol].FilterName) {
              filterColumnsList.push(filteredColumns[filterColDropdown]);
            }
          }
        }
        setFilterColumnListData(filterColumnsList);
      }

      filterData.push({
        FilterName: "",
        FilterOperator: "",
        FilterValue: "",
      });

      return filterData;
    });
  };

  const deleteRow = (index: number) => {
    setFilterValue((prevState) => {
      const filterData: IFilterItemProps[] = [...prevState];
      filterData.splice(index, 1);
      return filterData;
    });
  };

  const handleSave = () => {
    const test = filterValue[0].FilterValue == "" ? false : true;
    if (test) {
      setOpenFilter(false);
      setOrderListParams((prev) => ({
        ...prev,
        classNumber: "",
        account: "",
        userFullName: "",
        orderStateName: "",
        orderTotal: "",
        globalSearch: "",
        operatorClassNumber: "",
        operatorAccountName: "",
        operatorUserName: "",
        operatorOrderStateName: "",
        operatorOrderTotal: "",
        operatorAssignToFullName: "",
        assignToFullName: "",
        operatormodifiedDate: "",
        modifiedDate: "",
        operatorcreatedDate: "",
        createdDate: "",
      }));
      manageFilter && manageFilter(filterValue);
      setLocalStorageDataForFilters(FILTERVALUE, filterValue);
      removeLocalStorageData(ORDERTYPE);
      removeLocalStorageData(STORELIST);
    } else {
      setOpenFilter(false);
      notificationController.error({
        message: translate("manageOrder.columnSelectionErrorMessage"),
        placement: "top",
      });
    }
  };

  const filterListToShow = initialFilterColumnList();
  const selectedValues = filterValue.map((el)=>{
    return el.FilterName;
  });
  
  return (
    <Space size={16} direction="vertical">
      {filterValue &&
        filterValue?.length > 0 &&
        filterValue.map((item: IFilterItemProps, i: number) => {
          // if (clickedAppliedFilter && clickedAppliedFilter == item.FilterName) {
          return (
            <Space direction="horizontal" className="d-flex justify-between" key={`filters${i}`}>
              <Select
                placeholder="Select Column"
                options={filterListToShow?.filter((item)=>{
                  return !selectedValues?.includes(item.key);
                })}
                showSearch={true}
                data-test-selector="drpColumn"
                onChange={(value) => {
                  onChangeHandler(value, "FilterName", i);
                }}
                value={item.FilterName || undefined}
                style={{ width: 180 }}
                fieldNames={{ label: "title", value: "key" }}
              />
              <Select
                placeholder=""
                options={FiltersList}
                showSearch={true}
                data-test-selector="drpFilterType"
                onChange={(value) => {
                  onChangeFilterHandler(value, "FilterOperator", i);
                }}
                value={item.FilterOperator || undefined}
                allowClear={true}
                style={{ width: 180 }}
              />
              <Input
                data-test-selector="txtFilterValue"
                value={item.FilterValue || ""}
                onChange={(e) => {
                  onChangeFilterHandler(e?.target?.value, "FilterValue", i);
                }}
              />
              <CloseCircleOutlined
                onClick={() => {
                  deleteRow(i);
                }}
                style={i == 0 ? { display: "none" } : { color: "#000" }}
              />
            </Space>
          );
          // }
          // if (clickedAppliedFilter === "filterTitle") {
          //   return (
          //     <Space direction="horizontal" className="d-flex justify-between" key={`filters${i}`}>
          //       <Select
          //         placeholder="Select Column"
          //         options={filterColumnListData}
          //         showSearch={true}
          //         data-test-selector="drpColumn"
          //         onChange={(value) => {
          //           onChangeHandler(value, "FilterName", i);
          //         }}
          //         value={item.FilterName || undefined}
          //         style={{ width: 180 }}
          //         fieldNames={{ label: "title", value: "key" }}
          //       />
          //       <Select
          //         placeholder=""
          //         options={FiltersList}
          //         showSearch={true}
          //         data-test-selector="drpFilterType"
          //         onChange={(value) => {
          //           onChangeFilterHandler(value, "FilterOperator", i);
          //         }}
          //         value={item.FilterOperator || undefined}
          //         allowClear={true}
          //         style={{ width: 180 }}
          //       />
          //       <Input
          //         data-test-selector="txtFilterValue"
          //         value={item.FilterValue || ""}
          //         onChange={(e) => {
          //           onChangeFilterHandler(e?.target?.value, "FilterValue", i);
          //         }}
          //       />
          //       <CloseCircleOutlined
          //         onClick={() => {
          //           deleteRow(i);
          //         }}
          //         style={i == 0 ? { display: "none" } : { color: "#000" }}
          //       />
          //     </Space>
          //   );
          // }
        })}
      <Space className="d-flex justify-end">
        <Button ghost type="primary" data-test-selector={"btnSave"} onClick={closePopOver}>
          Cancel
        </Button>

        <Button
          type="primary"
          data-test-selector={"btnSave"}
          disabled={filterColumnListData.length == 0}
          onClick={onAddFilterPress}
        >
          Add Filter
        </Button>

        <Button type="primary" data-test-selector={"btnSave"} onClick={handleSave}>
          Apply Filter
        </Button>
      </Space>
    </Space>
  );
};
