/* eslint-disable max-lines */
/* eslint-disable max-len */
/* eslint-disable max-lines-per-function */
/* eslint-disable-next-line @typescript-eslint/no-inferrable-types*/
/* eslint-disable indent */
import React, { useCallback, useContext, useEffect, useMemo, useState } from "react";
import {
  Typography,
  Col,
  Row,
  Button,
  Input,
  Card,
  Space,
  Table,
  Modal,
  Spin,
  Divider,
} from "antd";
import { PlusOutlined, SearchOutlined, CloseCircleOutlined } from "@ant-design/icons";
import OrderFilters from "./OrderFilter";
import OrderActionFilters from "./OrderActionFilter";
import {
  columns,
  getQuickViewData,
  filterColumns,
  initialColumns,
  getSmartViewOrderList,
  initialFilterColumnList,
  checkAssignToMyTeamPermission,
  checkAssignToMePermission,
} from "./Order.Constant";
import CollapseComponent from "components/Common/Collapse/Collapse";
import {
  IDeleteSavedView,
  IFilterItemProps,
  IDuplicateOrder,
  IOrderListData,
  ISavedViewList,
  ISavedViewListProps,
  ISavedViewItemProps,
  StoreListProps,
  collapseItem,
  IUserGroupListProps,
  ICreateMappingSavedView,
  priorityView,
  IUpdateViewPriorityList,
  IMultipleShareSavedView,
  IMultipleShareViewForEveryOne,
} from "interfaces/ClientInterface/IOrderList";
import { Collapse } from "antd";
import { useNavigate } from "react-router-dom";
import {
  ALLORDER,
  Account,
  Age,
  AllStores,
  CPSmartView,
  CREATEDDATE,
  Customer,
  Delete,
  Editsave,
  GENERATE_INVOICE_API,
  GET_DATA_FOR_QUICKVIEW_API,
  MODIFIEDDATE,
  MultipleShare,
  OrderNumber,
  OrderStateName,
  OrderTotal,
  Owner,
  Priority1,
  Priority2,
  Priority3,
  SAVEDVIEWFILTER,
  TYPEAHEAD_TYPE,
  TYPEAHEAD_TYPE_NAME,
  Total,
  UserName,
} from "config/constant";
import { getUserDetails } from "api/services/localStorage.service";
import { ArrowLeftOutlined } from "@ant-design/icons";
import "./Orders.scss";
import List from "components/Common/List/List";
import { IColumnProps } from "interfaces/ClientInterface/IEditOrder";
import { notificationController } from "components/Common/Notification/Notification";
import { IStoreList } from "interfaces/APIInterface/ICreateOrder";
import {
  getOrderList,
  getSavedView,
  getSavedViewList,
  getStoreList,
  //getUserGroupList,
  saveSavedView,
  deleteSavedView,
  duplicateOrder,
  createSavedViewMapping,
  UpdateViewPriority,
  getSavedViewUserGroupIds,
  MultipleShareViewWithUserGroups,
  MultipleShareViewWithPublic,
  deleteSavedViewMapping,
  getAssociatedUserGroupsListByUserId,
} from "api/services/manageOrder.api";
import { getGlobalSetting, readUserId } from "api/services/localStorage.service";
import { httpApi } from "api/http.api";
import { IInvoiceListResponse, InvoiceList } from "interfaces/APIInterface/IInvoiceDocument";
import InvoiceDocument from "./InvoiceDocument";
import { ROUTES_PATH } from "routes/Routes.Constant";
import { IOrderDetails } from "interfaces/APIInterface/IQuickViewOrder";
import { IAssignModal, IQuickViewOpen } from "interfaces/ClientInterface/IQuickViewOrder";
import DuplicateModalComponent from "components/Common/DuplicateModal/DuplicateModal";
import {
  IDuplicateOrderPayload,
  IGetSavedViewData,
  IGetSavedViewListData,
} from "interfaces/APIInterface/IOrderList";
import { IAssignUnassign, IUsersListItem } from "interfaces/APIInterface/IAssignTo";
import { getUsersInMyTeam } from "api/services/assignTo.api";
import { updateOrderFollowers, updateOrderOwner } from "api/services/editOrder.api";
import { translate } from "i18n";
import { AbilityContext } from "ability/can";
import { IFollowUnfollow } from "interfaces/APIInterface/IFollowUnfollow";
import { PureAbility } from "@casl/ability";
import { deepCloneArray } from "utils";
import { IData } from "interfaces/ClientInterface/IList";
import dayjs from "dayjs";
import { TimezoneMapper } from "config/timeZone";
import { getEditOrderPermissionsData } from "api/services/permission.api";
import { PERMISSION_CODE, PERMISSION_SUBJECT } from "ability/utils";
import { themeSetting } from "config/defaultSettings";
import { getLocalStorageData, removeLocalStorageData } from "utils/localStorage";
import { Link } from "react-router-dom";
import { TABLECOLUMN, FILTERVALUE, ORDERTYPE, STORELIST } from "config/constant";
import { CaretDownOutlined } from "@ant-design/icons";
import { Filters } from "./Filters";

const { Panel } = Collapse;
const { Title, Text } = Typography;
const globalSettings = getGlobalSetting() ? JSON.parse(getGlobalSetting() || "") : {};
const serverTimeZone = globalSettings?.ServerTimeZone;
let isFilterApplied = true;
let isGetViewWithFilters = false;
// eslint-disable-next-line max-lines-per-function
const ManageOrders = () => {
  const ability: PureAbility<[string, string]> = useContext(AbilityContext);
  const localOrderType =
    getLocalStorageData(ORDERTYPE) !== null ? getLocalStorageData(ORDERTYPE) : "";
  const localStoreType =
    getLocalStorageData(STORELIST) !== null ? getLocalStorageData(STORELIST) : "";
  const savedViewType =
    getLocalStorageData(SAVEDVIEWFILTER) !== null ? getLocalStorageData(SAVEDVIEWFILTER) : "";
  const navigate = useNavigate();
  const [orderListParams, setOrderListParams] = useState({
    portalId: -1,
    classNumber: "",
    category: "MyOrder_IN PROGRESS",
    account: "",
    userFullName: "",
    orderStateName: "",
    orderTotal: "",
    assignToFullName: "",
    globalSearch: "",
    operatorClassNumber: "",
    operatorAccountName: "",
    operatorUserName: "",
    operatorOrderStateName: "",
    operatorOrderTotal: "",
    operatorAssignToFullName: "",
    operatormodifiedDate: "",
    modifiedDate: "",
    operatorcreatedDate: "",
    createdDate: "",
    columnSorting: "",
  } as IOrderListData);
  const [activeAccordionKey, setActiveAccordionKey] = useState<string | string[]>("0");
  const [dataList, setDataList] = useState<IData[]>([]);
  const columnData = initialColumns();
  const filterColumnData = initialFilterColumnList();
  const [filterColumnListData, setFilterColumnListData] = useState(
    filterColumnData as IColumnProps[]
  );
  const [columnsList, setColumnsList] = useState(columnData as IColumnProps[]);
  const [searchKeyword, setSearchKeyword] = useState<string>("");
  const [savedView, setSavedView] = useState<ISavedViewListProps[]>([]);
  const [filters, setFilters] = useState({
    orderType: localOrderType ? localOrderType : "",
    storeName: localStoreType ? parseInt(localStoreType) : -1,
    orderTools: "Tools",
    userGroup: 0,
    selectedView: savedViewType ? parseInt(savedViewType) : 0,
    selectedOrderTypeClass: localOrderType ? "active-select" : "",
    selectedStoreClass: localStoreType ? "active-select" : "",
  });
  const [storeList, setStoreList] = useState<StoreListProps[]>([]);
  const [userGroupList, setUserGroupList] = useState<IUserGroupListProps[]>([]);
  const [myTeam, setMyTeam] = useState<IUsersListItem[]>([]);
  const [checkedSaveView, setCheckedSavedView] = useState<number[]>([]);

  const [selectedRowKeys, setSelectedRowKeys] = useState<React.Key[]>([]);
  const [invoiceData, setInvoiceData] = useState<InvoiceList[]>([]);
  const [invoiceLoader, setInvoiceLoader] = useState<boolean>(false);
  const [openPdfModal, setOpenPdfModal] = useState(false);
  const [isDuplicateOrder, setIsDuplicateOrder] = useState<IDuplicateOrder>({
    visible: false,
    orderId: "",
  });

  const [quickViewData, setQuickViewData] = useState<IOrderDetails>({} as IOrderDetails);
  const [quickViewLoading, setQuickViewLoading] = useState<boolean>(false);
  const [isGetSavedViewWithOrderTypeFilters, setIsGetSavedViewWithOrderTypeFilters] =
    useState<string>();
  const [isGetSavedViewWithStoreNameFilters, setIsGetSavedViewWithStoreNameFilters] =
    useState<string>();
  const [quickViewOpen, setQuickViewOpen] = useState<IQuickViewOpen>({
    id: "",
    visible: false,
  });
  const [isLoading, setLoading] = useState(false);
  const [assignToModalOpen, setAssignToModalOpen] = useState<IAssignModal>({
    id: "",
    visible: false,
    IsDelegatedToMe: false,
  });
  const [sortingColumn, setSortingColumn] = useState({
    sortByColumnName: "",
    sortType: "",
  });
  const [assignToMyTeamModal, setAssignToMyTeamModal] = useState<boolean>(false);
  const [filterValue, setFilterValue] = useState<IFilterItemProps[]>([
    {
      FilterName: "",
      FilterOperator: "",
      FilterValue: "",
    },
  ]);
  const [appliedFilters, setAppliedFilters] = useState<IFilterItemProps[]>([]);
  const [priorityView, setPriorityView] = useState<priorityView[]>([
    {
      priority: 1,
      ViewId: -1,
      viewName: "",
    },
    {
      priority: 2,
      ViewId: -1,
      viewName: "",
    },
    {
      priority: 3,
      ViewId: -1,
      viewName: "",
    },
  ]);
  const [selectedSaveView, setselectedSaveView] = useState(Number);
  const [appliedSortingView, setappliedSortingView] = useState("");
  const [isFilterClear, setIsFilterClear] = useState<boolean>(true);
  const [shareWithUserGroup, setShareWithUserGroup] = useState(false as boolean);
  const [shareWithEveryone, setShareWithEveryone] = useState<boolean>(false);
  const [viewRedirection, setViewRedirection] = useState<boolean>(false);
  const [isAppliedSearchOrFilters, setIsAppliedSearchOrFilters] = useState(false);
  const [isChangeCommonView, setIsChangeCommonView] = useState(false);
  const [currentPage, setCurrentPage] = useState(1 as number);
  const [openFilter, setOpenFilter] = useState<boolean>(false);
  const [modalStyle, setModalStyle] = useState({});
  const [clickedAppliedFilter, setClickedAppliedFilter] = useState("");

  let getAppliedFilter = useMemo(() => {
    return {
      orderType: "",
      storeName: -1,
      orderTools: "",
      userGroup: 0,
      selectedView: 0,
      selectedOrderTypeClass: "",
      selectedStoreClass: "",
    };
  }, []);

  useEffect(() => {
    if (openPdfModal) {
      onPrint();
    } else {
      setInvoiceData([]);
    }
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [openPdfModal]);

  useEffect(() => {
    if (savedView?.length) {
      getUserGroupIds();
    }
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [savedView?.length]);

  /**
   * Get the user groups ids
   */
  const getUserGroupIds = () => {
    const filteredData = savedView?.map((item: ISavedViewListProps) => {
      return item?.ViewId;
    });
    const getUserGroupId = filteredData?.length ? filteredData?.join(",") : null;
    getSavedViewUserGroupIds(getUserGroupId)
      .then((response) => {
        const res = response?.data?.SavedView;
        const result = savedView?.map((item) => {
          const isUserGroupPresent = res?.find((el: IGetSavedViewListData) => {
            return el?.ListViewId == item?.ViewId;
          });
          item.UserGroupId = isUserGroupPresent?.UserGroupId || 0;
          return item;
        });
        setSavedView(result);
      })
      .catch((err) => {
        setLoading(false);
        notificationController.error({ message: err.message });
      });
  };

  const onQuickView = (recordId: string) => {
    setQuickViewLoading(true);
    httpApi
      .get(GET_DATA_FOR_QUICKVIEW_API + "/" + recordId)
      .then((response) => {
        const data = response?.data?.Order;
        const quickViewDetails = getQuickViewData(data);
        setQuickViewData(quickViewDetails);
        setQuickViewLoading(false);
      })
      .catch((err) => {
        setQuickViewLoading(false);
        notificationController.error({ message: err.message });
      });
    setTimeout(() => {
      setQuickViewOpen({ id: recordId, visible: true });
    });
  };

  const onPrint = () => {
    setInvoiceLoader(true);
    httpApi
      .get(GENERATE_INVOICE_API + "/" + selectedRowKeys?.join(","))
      .then((response) => {
        const data = response?.data?.InvoiceList?.InvoiceList;
        data?.map((el: IInvoiceListResponse) => {
          el.OrderDetail = JSON?.parse(el?.OrderDetail);
          return el;
        });
        setInvoiceData(data);
        setInvoiceLoader(false);
      })
      .catch((err) => {
        setInvoiceLoader(false);
        setOpenPdfModal(false);
        notificationController.error({ message: err.message });
      });
  };

  const rowSelection = {
    selectedRowKeys,
    onChange: (selectedRowKeys: React.Key[]) => {
      setSelectedRowKeys(selectedRowKeys);
    },
  };

  const onEditItemPress = (data: string) => {
    navigate(`/${ROUTES_PATH.EDIT_ORDER}/${data}`);
  };
  /**
   * Get the filtered order list as per the accordion
   *    * @param key
   */
  const accordionChangeHandler = (key: string | string[]) => {
    setActiveAccordionKey(key);
    setOrderListParams((prev) => ({
      ...prev,
      category: key?.[0],
    }));
  };
  /**
   * Get the list of order as per user is searched
   */
  const searchOrder = () => {
    if (searchKeyword != "") {
      setIsAppliedSearchOrFilters(true);
      setFilters((prevState) => ({
        ...prevState,
        storeName: -1,
        selectedView: 0,
        selectedStoreClass: "",
        selectedOrderTypeClass: "active-select",
      }));
      setOrderListParams((prev) => ({
        ...prev,
        category: "",
        globalSearch: searchKeyword.trim(),
        portalId: 0,
      }));
    }
  };

  const allOrdersHandler = () => {
    setLoading(true);
    const orderRequestPayload: IOrderListData = orderListParams;
    getOrderList(orderRequestPayload)
      .then((response) => {
        const data: IData[] = response?.data?.OrderList;
        data?.forEach((element) => {
          const currentDate = dayjs().tz(TimezoneMapper[serverTimeZone]);
          const CreatedDate = dayjs.utc(element.CreatedDate).tz(TimezoneMapper[serverTimeZone]);

          const duration = dayjs(currentDate).diff(dayjs(CreatedDate), "hour");
          const days = Math.floor(duration / 24);
          const hours = duration % 24;

          if (days == 1 && hours == 1) {
            element.Age = `${days} day ${hours} hr`;
          } else if (days == 1 && hours > 1) {
            element.Age = `${days} day ${hours} hrs`;
          } else if (days > 1 && hours > 1) {
            element.Age = `${days} days ${hours} hrs`;
          } else if (days > 1 && hours == 1) {
            element.Age = `${days} days ${hours} hr`;
          } else if (days > 1 && hours == 0) {
            element.Age = `${days} days`;
          } else if (days == 1 && hours == 0) {
            element.Age = `${days} day`;
          }else if (days == 0 && hours == 1) {
            element.Age = `${hours} hr`;
          }else if (days == 0 && hours > 1) {
            element.Age = `${hours} hrs`;
          }else if (days == 0 && hours < 1) {
            element.Age = "0 hr";
          }
          
        });
        setDataList(data);
        setLoading(false);
      })
      .catch((err) => {
        setLoading(false);
        notificationController.error({ message: err.message });
      });
  };
  /**
   * Get the User group list and saved view list.
   */
  useEffect(() => {
    fetchStoreList();
    fethchUserGroupList();
    fetchSavedViewList();
    fetchUsersInMyTeam();
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, []);

  /**
   * Get the list of order when user selects the all store dropdown and all orders dropdown
   */
  useEffect(() => {
    const localData = getLocalStorageData(FILTERVALUE);
    const parsedLocalFilterData = localData !== null ? JSON.parse(localData) : "";
    if (filters?.orderType !== "" || filters?.storeName !== -1) {
      setOrderListParams((prev) => ({
        ...prev,
        portalId: filters.storeName,
        category: filters.orderType,
        columnSorting: appliedSortingView,
      }));
      setSelectedRowKeys([]);
      if (
        isGetSavedViewWithOrderTypeFilters != filters?.orderType ||
        Number(isGetSavedViewWithStoreNameFilters) != filters?.storeName
      ) {
        if (filters?.orderType !== "MyOrder" || isChangeCommonView) {
          setIsChangeCommonView(true);

          setOrderListParams((prev) => ({
            ...prev,
            classNumber: "",
            account: "",
            userFullName: "",
            orderStateName: "",
            orderTotal: "",
            globalSearch: "",
            operatorClassNumber: "",
            operatorAccountName: "",
            operatorUserName: "",
            operatorOrderStateName: "",
            operatorOrderTotal: "",
            operatorAssignToFullName: "",
            assignToFullName: "",
            operatormodifiedDate: "",
            modifiedDate: "",
            operatorcreatedDate: "",
            createdDate: "",
          }));
          if (!parsedLocalFilterData) {
            setAppliedFilters([]);
            setFilterValue([]);
            setFilterValue((prevState) => {
              const filterData: IFilterItemProps[] = [...prevState];
              filterData.push({
                FilterName: "",
                FilterOperator: "",
                FilterValue: "",
              });
              return filterData;
            });
          }
        }
      }

      setSearchKeyword("");
      setIsAppliedSearchOrFilters(false);
    } // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [filters?.orderType, filters?.storeName, appliedSortingView]);

  useEffect(() => {
    const tableColumnData = getLocalStorageData(TABLECOLUMN);
    if (tableColumnData) {
      const parsedData = tableColumnData !== null ? JSON.parse(tableColumnData) : "";
      const newParsedData = [];
      for (let i = 0; i < parsedData.length; i++) {
        if (parsedData[i].title === OrderNumber) {
          newParsedData.push({
            ...parsedData[i],
            sorter: (prevValue: { ClassNumber: string }, currValue: { ClassNumber: string }) => {
              const orderCode = prevValue?.ClassNumber || "";
              const orderName = currValue?.ClassNumber || "";
              return orderCode.localeCompare(orderName);
            },
            hidden: false,
            render: (ClassNumber: string, record: IData) => (
              <Link
                to={`/${ROUTES_PATH.EDIT_ORDER}/${record?.OrderId}`}
                target="_self"
                className="link-inherit"
                onClick={(e) => e.stopPropagation()}
              >
                {ClassNumber}
              </Link>
            ),
          });
        } else {
          newParsedData.push(parsedData[i]);
        }
      }
      setColumnsList(newParsedData);
    } else {
      setColumnsList(columnData);
    }
    allOrdersHandler();
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [orderListParams]);

  useEffect(() => {
    if (searchKeyword?.length == 0 && isAppliedSearchOrFilters) {
      setIsAppliedSearchOrFilters(false);
      setOrderListParams((prev) => ({
        ...prev,
        category: "MyOrder",
        globalSearch: searchKeyword,
      }));
      setFilters((prevState) => ({
        ...prevState,
        orderType: "MyOrder",
      }));
    }
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [searchKeyword]);

  /**
   * Get the user group list for dropdown of saved view
   */
  const fetchStoreList = () => {
    const typeaheadRequestPayload: IStoreList = {
      MappingId: 0,
      PageSize: 0,
      FieldName: "",
      Type: TYPEAHEAD_TYPE,
      TypeName: TYPEAHEAD_TYPE_NAME,
      Searchterm: "",
    };

    getStoreList(typeaheadRequestPayload).then((response) => {
      const data = response?.data?.Typeaheadlist;
      data.push({ Name: AllStores, Id: 0 });
      setStoreList(data);
    });
  };
  /**
   * Get the saved view list
   */
  const fetchSavedViewList = () => {
    setSavedView([]);
    const itemName = CPSmartView;

    getSavedViewList(itemName)
      .then((response) => {
        const data = response?.data?.XMLSetting?.Views;
        setSavedView(data);
        const priorityData = [1, 2, 3]?.map((item) => {
          return {
            priority: item,
            ViewId:
              data.find((el: IGetSavedViewListData) => {
                return el?.ViewPriority == item;
              })?.ViewId || -1,
            viewName:
              data.find((el: IGetSavedViewListData) => {
                return el?.ViewPriority == item;
              })?.ViewName || "",
          };
        });
        setPriorityView(priorityData);
      })
      .catch((err) => {
        notificationController.error({ message: err.message });
      });
  };

  /**
   * Get user Group list
   */
  const fethchUserGroupList = () => {
    getAssociatedUserGroupsListByUserId()
      .then((response) => {
        // eslint-disable-next-line @typescript-eslint/no-unused-vars, no-unused-vars
        const data = response?.data?.UserGroupList;
        setUserGroupList(data);
      })
      .catch((err) => {
        notificationController.error({ message: err.message, placement: "top" });
      });
  };
  /**
   * Get the list of filtered order list when user apply the filter from filter dropdown
   * @param payload
   */
  const manageFilter = (payload: IFilterItemProps[]) => {
    isFilterApplied = true;

    payload.forEach(function (value) {
      if (value.FilterName != "" && value.FilterOperator != "" && value.FilterValue != "") {
        if (value.FilterName == OrderNumber) {
          setOrderListParams((prev) => ({
            ...prev,
            classNumber: value.FilterValue,
            operatorClassNumber: value.FilterOperator,
          }));
        } else if (value.FilterName == Account) {
          setOrderListParams((prev) => ({
            ...prev,
            account: value.FilterValue,
            operatorAccountName: value.FilterOperator,
          }));
        } else if (value.FilterName == Customer) {
          setOrderListParams((prev) => ({
            ...prev,
            userFullName: value.FilterValue,
            operatorUserName: value.FilterOperator,
          }));
        } else if (value.FilterName == OrderStateName) {
          setOrderListParams((prev) => ({
            ...prev,
            orderStateName: value.FilterValue,
            operatorOrderStateName: value.FilterOperator,
          }));
        } else if (value.FilterName == Total) {
          setOrderListParams((prev) => ({
            ...prev,
            orderTotal: value.FilterValue,
            operatorOrderTotal: value.FilterOperator,
          }));
        } else if (value.FilterName == Owner) {
          setOrderListParams((prev) => ({
            ...prev,
            assignToFullName: value.FilterValue,
            operatorAssignToFullName: value.FilterOperator,
          }));
        } else if (value.FilterName == CREATEDDATE) {
          setOrderListParams((prev) => ({
            ...prev,
            orderCreatedDate: value.FilterValue,
            operatorCreateDate: value.FilterOperator,
          }));
        } else if (value.FilterName == MODIFIEDDATE) {
          setOrderListParams((prev) => ({
            ...prev,
            orderModifiedDate: value.FilterValue,
            operatormodifiedDate: value.FilterOperator,
          }));
        }
      } else if (value.FilterName == "" || value.FilterOperator == "" || value.FilterValue == "") {
        isFilterApplied = false;
        notificationController.error({
          message: translate("manageOrder.columnSelectionErrorMessage"),
          placement: "top",
        });
      } else {
        isFilterApplied = false;
      }
    });
    if (isFilterApplied) {
      setAppliedFilters(deepCloneArray(payload));
      setIsFilterClear(false);
    }
    if (!isGetViewWithFilters && filters.selectedStoreClass == "") {
      setSearchKeyword("");
      setFilters((prevState) => ({
        ...prevState,
        orderType: filters?.orderType == "" ? "MyOrder" : filters?.orderType,
        selectedOrderTypeClass: "active-select",
      }));
    }
    getAppliedFilter = filters;
  };

  const localManageFilter = useCallback(
    (payload: IFilterItemProps[]) => {
      isFilterApplied = true;

      payload.forEach(function (value) {
        if (value.FilterName != "" && value.FilterOperator != "" && value.FilterValue != "") {
          if (value.FilterName == OrderNumber) {
            setOrderListParams((prev) => ({
              ...prev,
              classNumber: value.FilterValue,
              operatorClassNumber: value.FilterOperator,
            }));
          } else if (value.FilterName == Account) {
            setOrderListParams((prev) => ({
              ...prev,
              account: value.FilterValue,
              operatorAccountName: value.FilterOperator,
            }));
          } else if (value.FilterName == Customer) {
            setOrderListParams((prev) => ({
              ...prev,
              userFullName: value.FilterValue,
              operatorUserName: value.FilterOperator,
            }));
          } else if (value.FilterName == OrderStateName) {
            setOrderListParams((prev) => ({
              ...prev,
              orderStateName: value.FilterValue,
              operatorOrderStateName: value.FilterOperator,
            }));
          } else if (value.FilterName == Total) {
            setOrderListParams((prev) => ({
              ...prev,
              orderTotal: value.FilterValue,
              operatorOrderTotal: value.FilterOperator,
            }));
          } else if (value.FilterName == Owner) {
            setOrderListParams((prev) => ({
              ...prev,
              assignToFullName: value.FilterValue,
              operatorAssignToFullName: value.FilterOperator,
            }));
          } else if (value.FilterName == CREATEDDATE) {
            setOrderListParams((prev) => ({
              ...prev,
              orderCreatedDate: value.FilterValue,
              operatorCreateDate: value.FilterOperator,
            }));
          } else if (value.FilterName == MODIFIEDDATE) {
            setOrderListParams((prev) => ({
              ...prev,
              orderModifiedDate: value.FilterValue,
              operatormodifiedDate: value.FilterOperator,
            }));
          }
        } else if (
          value.FilterName == "" ||
          value.FilterOperator == "" ||
          value.FilterValue == ""
        ) {
          isFilterApplied = false;
          notificationController.error({
            message: translate("manageOrder.columnSelectionErrorMessage"),
            placement: "top",
          });
        } else {
          isFilterApplied = false;
        }
      });
      if (isFilterApplied) {
        setAppliedFilters(deepCloneArray(payload));
        setIsFilterClear(false);
      }
      if (!isGetViewWithFilters && getAppliedFilter.selectedStoreClass == "") {
        setSearchKeyword("");
        setFilters((prevState) => ({
          ...prevState,
          orderType: getAppliedFilter?.orderType == "" ? "MyOrder" : getAppliedFilter?.orderType,
          selectedOrderTypeClass: "active-select",
        }));
      }
    },
    [getAppliedFilter]
  );

  useEffect(() => {
    const localData = getLocalStorageData(FILTERVALUE);
    const parsedLocalData = localData !== null ? JSON.parse(localData) : "";
    const filterData: IFilterItemProps[] = [];
    if (parsedLocalData) {
      localManageFilter && localManageFilter(parsedLocalData);
      for (let i = 0; i < parsedLocalData.length; i++) {
        filterData.push({
          FilterName: parsedLocalData[i].FilterName,
          FilterOperator: parsedLocalData[i].FilterOperator,
          FilterValue: parsedLocalData[i].FilterValue,
        });
      }
      setFilterValue(filterData);
    }
  }, [localManageFilter]);
  /**
   * use for saved the view
   * @param Payload
   * @param userId
   */
  const fetchSavedView = (Payload: ISavedViewItemProps, userId: string) => {
    const filerIsExistsView = savedView?.filter((item) => {
      if (item?.ViewName == Payload?.newViewName) {
        return item;
      }
    });
    if (filerIsExistsView?.length > 0) {
      notificationController.error({
        message: translate("manageOrder.ErrorExistsViewName"),
        placement: "top",
      });
    } else {
      setFilters((prev) => ({
        ...prev,
        orderType: ALLORDER,
      }));
      const userGroupId = Payload.userGroup;
      const savedRequestPayload: ISavedViewList = {
        viewName: Payload.newViewName,
        IsPublic: Payload.shareWithEveryone,
        xmlSettingName: CPSmartView,
        xmlSetting: JSON.stringify(columnsList?.filter((item) => !item.hidden)),
        viewId: Payload.viewId,
        isDefault: Payload.isDefault,
        userId: userId,
        viewPriority: 0,
        sortColumn: sortingColumn.sortByColumnName,
        sortType: sortingColumn.sortType,
        Filters: filterValue,
        filterCategory:
          filters?.orderType +
          "," +
          filters?.storeName.toString() +
          "," +
          filters?.selectedOrderTypeClass +
          "," +
          filters.selectedStoreClass,
      };
      saveSavedView(savedRequestPayload)
        .then((response) => {
          let savedViewColumnList = [];
          const data = response?.data?.View;
          if (userGroupId) {
            CreateMappingView(data, userGroupId);
          }
          savedViewColumnList = JSON.parse(data?.XmlSetting);
          const matchCols = filterColumns(savedViewColumnList);
          setColumnsList(matchCols);
          fetchSavedViewList();
          notificationController.success({
            message: translate("manageOrder.isSavedViewSuccess"),
            placement: "top",
          });
        })
        .catch((err) => {
          notificationController.error({ message: err.message });
        });
    }
  };
  const CreateMappingView = (viewId: IGetSavedViewData, userGroupId: number) => {
    const savedRequestPayload: ICreateMappingSavedView = {
      listViewId: viewId.ViewId,
      userGroupId: userGroupId,
    };
    createSavedViewMapping(savedRequestPayload)
      .then((response) => {
        const data = response?.data;
        fetchSavedViewList();
        if (data.HasError) {
          notificationController.success({
            message: translate("manageOrder.isSavedViewSuccess"),
            placement: "top",
          });
        }
      })
      .catch((err) => {
        notificationController.error({ message: err.message });
      });
  };
  /**
   * Use for Edit the view in saved view dropdown
   * @param Payload
   * @param userId
   */
  const fetchEditView = (Payload: ISavedViewItemProps, userId: string) => {
    setFilters((prev) => ({
      ...prev,
      orderType: ALLORDER,
    }));
    const savedRequestPayload: ISavedViewList = {
      viewName: Payload.newViewName,
      IsPublic: Payload.shareWithEveryone,
      xmlSettingName: CPSmartView,
      xmlSetting: JSON.stringify(columnsList?.filter((item) => !item.hidden)),
      viewId: Payload.viewId,
      isDefault: Payload.isDefault,
      userId: userId,
      viewPriority: Payload.viewPriority,
      sortColumn: sortingColumn.sortByColumnName,
      sortType: sortingColumn.sortType,
    };
    saveSavedView(savedRequestPayload)
      .then((response) => {
        let savedViewColumnList = [];
        const data = response?.data?.View?.XmlSetting;
        // eslint-disable-next-line no-unused-vars
        savedViewColumnList = JSON.parse(data);
        const matchCols = filterColumns(savedViewColumnList);
        setColumnsList(matchCols);
        fetchSavedViewList();
        notificationController.success({
          message: translate("manageOrder.isEditViewSuccess"),
          placement: "top",
        });
      })
      .catch((err) => {
        notificationController.error({ message: err.message });
      });
  };
  /**
   * Use for delete the view
   * @param Payload
   */
  const DeleteView = (Payload: ISavedViewItemProps) => {
    const deleteRequestSavedView: IDeleteSavedView = {
      ids: Payload.viewId,
    };
    deleteSavedView(deleteRequestSavedView)
      .then((response) => {
        const data = response?.data?.IsSuccess;
        if (data) {
          fetchSavedViewList();
        }
        notificationController.success({
          message: translate("manageOrder.isDeleteViewSuccess"),
          placement: "top",
        });
      })
      .catch((err) => {
        notificationController.error({ message: err.message });
      });
  };
  /**
   * delete the view
   */
  const DeleteViewMapping = (Payload: ISavedViewItemProps) => {
    const deleteRequestSavedView: IDeleteSavedView = {
      ids: Payload.viewId,
    };
    deleteSavedViewMapping(deleteRequestSavedView)
      .then((response) => {
        // eslint-disable-next-line @typescript-eslint/no-unused-vars, no-unused-vars
        const data = response?.data?.IsSuccess;
        DeleteView(Payload);
      })
      .catch((err) => {
        notificationController.error({ message: err.message });
      });
  };
  /**
   * Update the Priority
   * @param Payload
   * @param userId
   */
  const EditViewPriority = (Payload: ISavedViewItemProps, userId: string) => {
    const UpdateViewPriorityPayload: IUpdateViewPriorityList = {
      viewName: Payload.newViewName,
      viewId: Payload.viewId,
      userId: userId,
      xmlSettingName: CPSmartView,
      viewPriority: Payload.viewPriority,
    };
    UpdateViewPriority(UpdateViewPriorityPayload)
      .then((response) => {
        // eslint-disable-next-line @typescript-eslint/no-unused-vars, no-unused-vars
        const data = response?.data?.View?.XmlSetting;
        fetchSavedViewList();
        notificationController.success({
          message: translate("manageOrder.UpdateThePriority"),
          placement: "top",
        });
      })
      .catch((err) => {
        notificationController.error({ message: err.message });
      });
  };

  /**
   * Use for manage Complete functionality of saved view
   * @param Payload
   */
  const manageSavedView = (Payload: ISavedViewItemProps) => {
    const userId = readUserId();
    if (Payload.type == "") {
      fetchSavedView(Payload, userId);
    } else if (Payload.type == Editsave) {
      fetchEditView(Payload, userId);
    } else if (Payload.type == Delete) {
      DeleteViewMapping(Payload);
    } else if (Payload.type == Priority1) {
      Payload.viewPriority = 1;
      EditViewPriority(Payload, userId);
    } else if (Payload.type == Priority2) {
      Payload.viewPriority = 2;
      EditViewPriority(Payload, userId);
    } else if (Payload.type == Priority3) {
      Payload.viewPriority = 3;
      EditViewPriority(Payload, userId);
    } else if (Payload.type == MultipleShare) {
      if (Payload.shareWithEveryone) {
        MultipleShareViewsForEveryOne(Payload);
      } else {
        MultipleShareViewsForUsers(Payload);
      }
    }
  };
  /**
   * Use for the get the existing view as per the id
   * @param Payload
   */
  const manageGetView = (viewId: number) => {
    setViewRedirection(true);
    setselectedSaveView(viewId);
    const getSavedViewRequestPayload = {
      viewId: viewId,
    };

    getSavedView(getSavedViewRequestPayload)
      .then((response) => {
        let savedViewColumnList = [];
        const data = response?.data?.View;
        savedViewColumnList = JSON.parse(data?.XmlSetting);
        const matchCols = filterColumns(savedViewColumnList);
        setColumnsList(matchCols);
        const filterCategory = data?.FilterCategory?.split(",");
        if (filterCategory?.length > 0) {
          setFilters((prev) => ({
            ...prev,
            orderType: filterCategory[0],
            storeName: Number(filterCategory[1]),
            selectedOrderTypeClass: filterCategory[2],
            selectedStoreClass: filterCategory[3],
          }));
          setIsGetSavedViewWithOrderTypeFilters(filterCategory[0]);
          setIsGetSavedViewWithStoreNameFilters(filterCategory[1]);
        }
        if (data?.Filters[0]?.FilterName != "" && data?.Filters.length > 0) {
          isGetViewWithFilters = true;

          manageFilter(data?.Filters);
        }
        const sortingView = data?.SortColumn + " " + data?.SortType;
        setappliedSortingView(sortingView);
        setFilters((prev) => ({
          ...prev,
          selectedView: viewId,
        }));
        setSortingColumn({
          sortByColumnName: data?.SortColumn,
          sortType: data?.SortType,
        });
        const sortType = sortingColumn.sortType;
        const sortColumn: string = sortingColumn.sortByColumnName;

        const dataSortList: IData[] = dataList;
        dataSortList?.sort((a: IData, b: IData) => {
          const aObj = a[sortColumn as keyof IData]?.toString() || "";
          const bObj = b[sortColumn as keyof IData]?.toString() || "";
          return sortType == "ASC" ? aObj.localeCompare(bObj) : bObj.localeCompare(aObj);
        });
        setDataList(dataSortList);
      })
      .catch((err) => {
        notificationController.error({ message: err.message });
      });
  };

  const customFilterManageGetView = useCallback((viewId: number) => {
    setViewRedirection(true);
    setselectedSaveView(viewId);
    const getSavedViewRequestPayload = {
      viewId: viewId,
    };

    getSavedView(getSavedViewRequestPayload)
      .then((response) => {
        let savedViewColumnList = [];
        const data = response?.data?.View;
        savedViewColumnList = JSON.parse(data?.XmlSetting);
        const matchCols = filterColumns(savedViewColumnList);
        setColumnsList(matchCols);
        const filterCategory = data?.FilterCategory?.split(",");
        if (filterCategory?.length > 0) {
          setFilters((prev) => ({
            ...prev,
            orderType: filterCategory[0],
            storeName: Number(filterCategory[1]),
            selectedOrderTypeClass: filterCategory[2],
            selectedStoreClass: filterCategory[3],
          }));
          setIsGetSavedViewWithOrderTypeFilters(filterCategory[0]);
          setIsGetSavedViewWithStoreNameFilters(filterCategory[1]);
        }
        const sortingView = data?.SortColumn + " " + data?.SortType;
        setappliedSortingView(sortingView);
        setFilters((prev) => ({
          ...prev,
          selectedView: viewId,
        }));
        setSortingColumn({
          sortByColumnName: data?.SortColumn,
          sortType: data?.SortType,
        });
      })
      .catch((err) => {
        notificationController.error({ message: err.message });
      });
  }, []);

  useEffect(() => {
    if (getLocalStorageData(SAVEDVIEWFILTER)) {
      const localIdValue = getLocalStorageData(SAVEDVIEWFILTER);
      const IdValue = localIdValue ? localIdValue : "";
      setFilters((prevState) => ({
        ...prevState,
        selectedOrderTypeClass: "",
        selectedStoreClass: "",
      }));

      customFilterManageGetView(parseInt(IdValue));
    }
  }, [dataList, customFilterManageGetView]);

  const MultipleShareViewsForUsers = (Payload: ISavedViewItemProps) => {
    const getUserGroupIds = checkedSaveView?.length ? checkedSaveView?.join(",") : null;
    const requestBody: IMultipleShareSavedView = {
      listViewIds: getUserGroupIds,
      userGroupId: Payload.userGroup,
    };
    MultipleShareViewWithUserGroups(requestBody)
      .then((response) => {
        const data = response?.data;
        if (data?.IsSuccess) {
          setShareWithEveryone(false);
          setShareWithUserGroup(false);
          setFilters((prevState) => ({
            ...prevState,
            userGroup: 0,
          }));
          setCheckedSavedView([]);
          fetchSavedViewList();
          notificationController.success({
            message: translate("manageOrder.isMultipleShareSuccess"),
          });
        }
      })
      .catch((err) => {
        notificationController.error({ message: err.message });
      });
  };
  const MultipleShareViewsForEveryOne = (Payload: ISavedViewItemProps) => {
    const getUserGroupIds = checkedSaveView?.length ? checkedSaveView?.join(",") : null;
    const requestBody: IMultipleShareViewForEveryOne = {
      listViewIds: getUserGroupIds,
      isPublic: Payload.shareWithEveryone,
      xmlSettingName: CPSmartView,
    };
    MultipleShareViewWithPublic(requestBody)
      .then((response) => {
        const data = response?.data;
        if (data?.IsSuccess) {
          setShareWithEveryone(false);
          setShareWithUserGroup(false);
          setFilters((prevState) => ({
            ...prevState,
            userGroup: 0,
          }));
          setCheckedSavedView([]);
          fetchSavedViewList();
          notificationController.success({
            message: translate("manageOrder.isMultipleShareSuccess"),
          });
        }
      })
      .catch((err) => {
        notificationController.error({ message: err.message });
      });
  };
  const duplicateRecord = (withShipping: boolean) => {
    const requestBody: IDuplicateOrderPayload = {
      OrderId: isDuplicateOrder?.orderId,
      IsCopyOrderShipment: withShipping,
    };
    duplicateOrder(requestBody)
      .then((response) => {
        const data = response?.data;
        if (data?.StatusModel?.Status) {
          notificationController.success({
            message: translate("manageOrder.recordDuplicateSuccessMessage"),
          });
          refetchList();
          handleBack();
          onEditItemPress(data?.StatusModel?.Id);
        }
      })
      .catch((err) => {
        notificationController.error({ message: err.message });
      });
  };

  const refetchList = () => {
    allOrdersHandler();
  };

  const handleBack = () => {
    setIsDuplicateOrder({
      visible: false,
      orderId: "",
    });
  };

  const handleWithoutShipping = () => {
    duplicateRecord(false);
  };

  const handleWithShipping = () => {
    duplicateRecord(true);
  };

  const onPrintClick = () => {
    if (selectedRowKeys?.length) {
      setOpenPdfModal(true);
    } else {
      notificationController.error({
        message: translate("manageOrder.isRecordsSelectedCheckMsg"),
      });
    }
  };

  const onAssignToMe = () => {
    if (selectedRowKeys?.length) {
      const filterUserId = myTeam.filter((item) =>
      // eslint-disable-next-line
      //@ts-ignore
      item.UserName === JSON.parse(getUserDetails()).UserName ? item.UserId : ""
    );
    
      const assignUnassignPayload: IAssignUnassign = {
        OrderIds: selectedRowKeys?.join(","),
        AssignTo: filterUserId[0].UserId,
        UserId: readUserId(),
      };
      updateOrderOwner(assignUnassignPayload).then((resp) => {
        if (resp[0].OrderDetailJson) {
          notificationController.error({
            message: translate("manageOrder.customMessage"),
            placement: "top",
          });
        } else {
          notificationController.success({
            message: translate("manageOrder.ownerAssignedSuccessMessage"),
            placement: "top",
          });
        }
        refetchList && refetchList();
        setSelectedRowKeys([]);
      });
    } else {
      notificationController.error({
        message: translate("manageOrder.isRecordsSelectedCheckMsg"),
      });
    }
  };

  const fetchUsersInMyTeam = () => {
    getUsersInMyTeam().then((response) => {
      const data = response?.data?.UsersInMyTeamModels;
      setMyTeam(data);
    });
  };

  const onUnassignOrder = () => {
    if (selectedRowKeys?.length) {
      const assignUnassignPayload: IAssignUnassign = {
        OrderIds: selectedRowKeys?.join(","),
        AssignTo: 0,
        UserId: readUserId(),
      };
      updateOrderOwner(assignUnassignPayload).then((response) => {
        if (response[0]?.OrderDetailJson) {
          notificationController.error({
            message: translate("manageOrder.customMessage"),
            placement: "top",
          });
        } else {
          notificationController.success({
            message: translate("manageOrder.ownerUnassignedSuccessMessage"),
          });
        }
        refetchList && refetchList();
        setSelectedRowKeys([]);
      });
    } else {
      notificationController.error({
        message: translate("manageOrder.isRecordsSelectedCheckMsg"),
      });
    }
  };

  const onFollow = () => {
    if (selectedRowKeys?.length) {
      const followUnfollowPayload: IFollowUnfollow = {
        OrderIds: selectedRowKeys?.join(","),
        AssignTo: Number(readUserId()),
        UserId: readUserId(),
        IsDeleted: false,
      };
      updateOrderFollowers(followUnfollowPayload).then(() => {
        notificationController.success({
          message: translate("manageOrder.recordFollowedSuccessMessage"),
        });
        refetchList && refetchList();
        setSelectedRowKeys([]);
      });
    } else {
      notificationController.error({
        message: translate("manageOrder.isRecordsSelectedCheckMsg"),
      });
    }
  };

  const onUnFollow = () => {
    if (selectedRowKeys?.length) {
      const followUnfollowPayload: IFollowUnfollow = {
        OrderIds: selectedRowKeys?.join(","),
        AssignTo: Number(readUserId()),
        UserId: readUserId(),
        IsDeleted: true,
      };
      updateOrderFollowers(followUnfollowPayload).then(() => {
        notificationController.success({
          message: translate("manageOrder.recoedUnfollowedSuccessMessage"),
        });

        setSelectedRowKeys([]);
        refetchList && refetchList();
      });
    } else {
      notificationController.error({
        message: translate("manageOrder.isRecordsSelectedCheckMsg"),
      });
    }
  };

  const toolsClickHandler = (toolsClickActionType: string) => {
    switch (toolsClickActionType) {
      case "print":
        onPrintClick();
        break;
      case "Assign_to_Me":
        onAssignToMe();
        break;
      case "Unassign_Order":
        onUnassignOrder();
        break;
      case "Follow":
        onFollow();
        break;
      case "Unfollow":
        onUnFollow();
        break;
      default:
        break;
    }
  };

  const removeSorter = (cols: IColumnProps[]) => {
    return deepCloneArray(cols)?.map((el: IColumnProps) => {
      delete el.sorter;
      return el;
    });
  };

  const removeAgeColumn = (cols: IColumnProps[]): IColumnProps[] => {
    const filteredCols = cols?.filter((col) => col.title !== Age);
    return filteredCols;
  };

  const onAssignClick = (orderId: string, orderStateId: number) => {
    const canAssignToMyTeamPermission = checkAssignToMyTeamPermission(ability);
    const canAssignToMePermission = checkAssignToMePermission(ability);
    const isAssignPermission = canAssignToMyTeamPermission || canAssignToMePermission;

    //given assign to action irrespective of the permission
    getEditOrderPermissionsData(orderId, orderStateId).then((response) => {
      const data = response?.ItemLevelPermissions;
      if (data?.IsEdit && (isAssignPermission || data?.IsDelegatedToMe)) {
        setTimeout(() => {
          setAssignToModalOpen({
            id: orderId,
            visible: true,
            IsDelegatedToMe: data?.IsDelegatedToMe,
          });
        });
      } else {
        notificationController.error({
          message: translate("login.invalidLoginPermission"),
          placement: "top",
        });
      }
    });
  };
  const deleteRow = (index: number) => {
    setFilterColumnListData(filterColumnData);
    setOrderListParams((prev) => ({
      ...prev,
      classNumber: "",
      account: "",
      userFullName: "",
      orderStateName: "",
      orderTotal: "",
      globalSearch: "",
      operatorClassNumber: "",
      operatorAccountName: "",
      operatorUserName: "",
      operatorOrderStateName: "",
      operatorOrderTotal: "",
      operatorAssignToFullName: "",
      assignToFullName: "",
      operatormodifiedDate: "",
      modifiedDate: "",
      operatorcreatedDate: "",
      createdDate: "",
    }));
    setFilterValue((prevState) => {
      const filterData: IFilterItemProps[] = [...prevState];
      filterData.splice(index, 1);
      filterData.forEach(function (value) {
        if (value.FilterName == OrderNumber) {
          setOrderListParams((prev) => ({
            ...prev,
            classNumber: value.FilterValue,
            operatorClassNumber: value.FilterOperator,
          }));
        } else if (value.FilterName == Account) {
          setOrderListParams((prev) => ({
            ...prev,
            account: value.FilterValue,
            operatorAccountName: value.FilterOperator,
          }));
        } else if (value.FilterName == UserName) {
          setOrderListParams((prev) => ({
            ...prev,
            userFullName: value.FilterValue,
            operatorUserName: value.FilterOperator,
          }));
        } else if (value.FilterName == OrderStateName) {
          setOrderListParams((prev) => ({
            ...prev,
            orderStateName: value.FilterValue,
            operatorOrderStateName: value.FilterOperator,
          }));
        } else if (value.FilterName == OrderTotal) {
          setOrderListParams((prev) => ({
            ...prev,
            orderTotal: value.FilterValue,
            operatorOrderTotal: value.FilterOperator,
          }));
        } else if (value.FilterName == Owner) {
          setOrderListParams((prev) => ({
            ...prev,
            assignToFullName: value.FilterValue,
            operatorAssignToFullName: value.FilterOperator,
          }));
        } else if (value.FilterName == CREATEDDATE) {
          setOrderListParams((prev) => ({
            ...prev,
            orderCreatedDate: value.FilterValue,
            operatorCreateDate: value.FilterOperator,
          }));
        } else if (value.FilterName == MODIFIEDDATE) {
          setOrderListParams((prev) => ({
            ...prev,
            orderModifiedDate: value.FilterValue,
            operatormodifiedDate: value.FilterOperator,
          }));
        }
      });
      if (filterData?.length == 0) {
        setFilterValue([]);
        setFilterValue((prevState) => {
          const filterData: IFilterItemProps[] = [...prevState];
          filterData.push({
            FilterName: "",
            FilterOperator: "",
            FilterValue: "",
          });
          return filterData;
        });
      }
      setAppliedFilters(filterData);
      return filterData;
    });
  };

  const ClearAllFilters = () => {
    setIsFilterClear(true);
    setAppliedFilters([]);
    setFilterValue([]);
    setFilterValue((prevState) => {
      const filterData: IFilterItemProps[] = [...prevState];
      filterData.push({
        FilterName: "",
        FilterOperator: "",
        FilterValue: "",
      });
      return filterData;
    });
    setFilterColumnListData(filterColumnData);
    setOrderListParams((prev) => ({
      ...prev,
      classNumber: "",
      account: "",
      userFullName: "",
      orderStateName: "",
      orderTotal: "",
      globalSearch: "",
      operatorClassNumber: "",
      operatorAccountName: "",
      operatorUserName: "",
      operatorOrderStateName: "",
      operatorOrderTotal: "",
      operatorAssignToFullName: "",
      assignToFullName: "",
      operatormodifiedDate: "",
      modifiedDate: "",
      operatorcreatedDate: "",
      createdDate: "",
    }));
    removeLocalStorageData(FILTERVALUE);
  };

  const quickViewProps = {
    quickViewOpen,
    setQuickViewOpen,
    quickViewData,
    onQuickView,
    quickViewLoading,
  };

  const assignToProps = {
    assignToModalOpen,
    setAssignToModalOpen,
    refetchList,
    myTeam,
    selectedRowKeys,
    setSelectedRowKeys,
    onAssignClick,
  };

  const actionColumn = columns(
    onEditItemPress,
    quickViewProps,
    setIsDuplicateOrder,
    activeAccordionKey,
    assignToProps,
    ability
  );
  const cols = [...columnsList, ...actionColumn];

  const smartViewTabs = getSmartViewOrderList(ability);

  const openModal = () => {
    const filterColumnData = initialFilterColumnList();
    setFilterColumnListData(filterColumnData);
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    const element: any = document?.getElementById("applied-filter-view-modal-wrapper");
    const { top } = element.getBoundingClientRect();
    const topPosition = top + 40;
    setModalStyle({
      top: `${topPosition}px`,
      marginRight: "560px",
    });
    if (isFilterClear) {
      setFilterValue([]);
      setFilterValue((prevState) => {
        const filterData: IFilterItemProps[] = [...prevState];
        filterData.push({
          FilterName: "",
          FilterOperator: "",
          FilterValue: "",
        });
        return filterData;
      });
    }
    setOpenFilter(true);
  };

  return (
    <Space direction="vertical" size="middle" className="d-flex manage-order-container">
      <Row>
        <Col span={12} xs={24} sm={24} md={12} lg={12} xl={12}>
          <Title level={3} className="m-0">
            {translate("manageOrder.Title")}
          </Title>
        </Col>
        <Col span={12} xs={24} sm={24} md={12} lg={12} xl={12}>
          <div className="d-flex justify-between">
            <Button
              type="primary"
              icon={<PlusOutlined />}
              size="large"
              className={
                ability.can(PERMISSION_CODE.CREATE_ORDERS, PERMISSION_SUBJECT.ORDERS)
                  ? "mr-15"
                  : "visibility-hidden mr-15"
              }
              data-test-selector="btnCreateOrder"
              onClick={() => navigate(`/${ROUTES_PATH.CREATE_ORDER}`)}
              disabled={!ability.can(PERMISSION_CODE.CREATE_ORDERS, PERMISSION_SUBJECT.ORDERS)}
            >
              {translate("manageOrder.createOrderTitle")}
            </Button>
            <Input
              placeholder="Search Orders"
              suffix={
                <div>
                  <SearchOutlined
                    style={{ color: "rgba(0,0,0,.45)" }}
                    className="search-icon-style"
                    onClick={searchOrder}
                  />
                </div>
              }
              data-test-selector="txtSearchOrder"
              value={searchKeyword}
              onChange={(e) => {
                setSearchKeyword(e?.target?.value);
              }}
              onPressEnter={searchOrder}
              allowClear={true}
            />
          </div>
        </Col>
      </Row>
      <Row>
        <Col span={24}>
          <Card bordered={true}>
            <Space direction="vertical" size="large" className="d-flex">
              <Row gutter={{ xs: 8, sm: 16, md: 24, lg: 32 }}>
                <Col className="gutter-row" span={16}>
                  <OrderFilters
                    filters={filters}
                    setFilters={setFilters}
                    storeList={storeList}
                    userGroupList={userGroupList}
                    savedView={savedView}
                    setSavedView={setSavedView}
                    manageSavedView={manageSavedView}
                    manageGetView={manageGetView}
                    setOrderListParams={setOrderListParams}
                    priorityView={priorityView}
                    setPriorityView={setPriorityView}
                    setCheckedSavedView={setCheckedSavedView}
                    checkedSaveView={checkedSaveView}
                    selectedSaveView={selectedSaveView}
                    filterValue={filterValue}
                    setFilterValue={setFilterValue}
                    setAppliedFilters={setAppliedFilters}
                    setSelectedRowKeys={setSelectedRowKeys}
                    shareWithUserGroup={shareWithUserGroup}
                    setShareWithUserGroup={setShareWithUserGroup}
                    shareWithEveryone={shareWithEveryone}
                    setShareWithEveryone={setShareWithEveryone}
                    isFilterClear={isFilterClear}
                    setViewRedirection={setViewRedirection}
                    setCurrentPage={setCurrentPage}
                    isAppliedSearchOrFilters={isAppliedSearchOrFilters}
                    setIsAppliedSearchOrFilters={setIsAppliedSearchOrFilters}
                  />
                </Col>
                <Col className="gutter-row justify-right align-center d-flex" span={8}>
                  <OrderActionFilters
                    columnsList={cols?.filter((item) => item.key != "action")}
                    setColumnsList={setColumnsList}
                    manageFilter={manageFilter}
                    toolsClickHandler={toolsClickHandler}
                    assignToMyTeamModal={assignToMyTeamModal}
                    setAssignToMyTeamModal={setAssignToMyTeamModal}
                    refetchList={refetchList}
                    myTeam={myTeam}
                    selectedRowKeys={selectedRowKeys}
                    setSelectedRowKeys={setSelectedRowKeys}
                    activeAccordionKey={activeAccordionKey}
                    filters={filters}
                    filterValue={filterValue}
                    setFilterValue={setFilterValue}
                    setOrderListParams={setOrderListParams}
                    setAppliedFilters={setAppliedFilters}
                    appliedFilters={appliedFilters}
                    setFilterColumnListData={setFilterColumnListData}
                    filterColumnListData={filterColumnListData}
                    isFilterClear={isFilterClear}
                    setIsFilterClear={setIsFilterClear}
                    clickedAppliedFilter={clickedAppliedFilter}
                    setClickedAppliedFilter={setClickedAppliedFilter}
                  />
                </Col>
              </Row>
              {appliedFilters.length > 0 ? (
                <Row>
                  <Space align="center" direction="horizontal" size={8} className="flex-wrap">
                    <div className="txt-bold text-color-gray">Applied Filters:</div>
                    <Space direction="horizontal" size={0} className="flex-wrap">
                      {appliedFilters.map((item: IFilterItemProps, i: number) => {
                        return (
                          <Space
                            align="center"
                            size={10}
                            key={`filtersApplied${i}`}
                            className="active-filter"
                          >
                            <span
                              onClick={() => {
                                openModal();
                                // setClickedAppliedFilter(item.FilterName);
                              }}
                              style={{ cursor: "pointer" }}
                              id="applied-filter-view-modal-wrapper"
                            >
                              <span>{`${item.FilterName} : ${item.FilterValue}`}</span>{" "}
                              <CaretDownOutlined />
                            </span>
                            <CloseCircleOutlined
                              onClick={() => {
                                deleteRow(i);
                                removeLocalStorageData(FILTERVALUE);
                              }}
                            />
                            <Modal
                              title={
                                <Space direction="vertical" className="d-flex">
                                  <Text>{translate("manageOrder.filterResult")}</Text>
                                  <Divider className="m-0" />
                                </Space>
                              }
                              open={openFilter}
                              onCancel={() => {
                                setOpenFilter(false);
                              }}
                              zIndex={10}
                              mask={false}
                              footer={null}
                              width={600}
                              style={modalStyle}
                              closable={false}
                            >
                              <Filters
                                setOpenFilter={setOpenFilter}
                                manageFilter={manageFilter}
                                filterValue={filterValue}
                                setFilterValue={setFilterValue}
                                setOrderListParams={setOrderListParams}
                                setAppliedFilters={setAppliedFilters}
                                appliedFilters={appliedFilters}
                                filterColumnListData={filterColumnListData}
                                setFilterColumnListData={setFilterColumnListData}
                                isFilterClear={isFilterClear}
                                setIsFilterClear={setIsFilterClear}
                                // clickedAppliedFilter={clickedAppliedFilter}
                              />
                            </Modal>
                          </Space>
                        );
                      })}
                    </Space>
                    <div
                      className="cursor-pointer"
                      onClick={ClearAllFilters}
                      style={{ color: themeSetting.token.colorPrimary }}
                    >
                      {translate("manageOrder.ClearAllFilters")}
                    </div>
                  </Space>
                </Row>
              ) : null}
              {filters?.orderType !== "" ||
              filters?.storeName != -1 ||
              viewRedirection ||
              isAppliedSearchOrFilters ? (
                <List
                  data={dataList}
                  columns={removeAgeColumn(cols?.filter((item) => !item.hidden))}
                  pagination={true}
                  classSelector={"dashboard-listing-container"}
                  isLoading={isLoading}
                  sortingColumn={sortingColumn}
                  setSortingColumn={setSortingColumn}
                  rowSelection={{
                    type: "checkbox",
                    ...rowSelection,
                  }}
                  currentPage={currentPage}
                  setCurrentPage={setCurrentPage}
                />
              ) : (
                <CollapseComponent
                  isAccordion={true}
                  customPanel={true}
                  size="small"
                  title=""
                  dataTestSelector="collapseOrderFlags"
                  onChange={accordionChangeHandler}
                  defaultActiveKey={"MyOrder_IN PROGRESS"}
                >
                  <>
                    {smartViewTabs &&
                      smartViewTabs?.map((item: collapseItem) => {
                        return (
                          <Panel
                            header={item.title}
                            key={item.key}
                            className={"collapse-panel-style" + " " + item.classSelector}
                          >
                            <Table
                              dataSource={dataList}
                              columns={removeSorter(cols?.filter((item) => !item.hidden))}
                              rowKey={(record) => record.OrderId}
                              pagination={{ position: ["bottomLeft"] }}
                              scroll={{ x: "max-content" }}
                              data-test-selector="tblProductList"
                              rowSelection={{
                                type: "checkbox",
                                ...rowSelection,
                              }}
                              loading={isLoading}
                            />
                          </Panel>
                        );
                      })}
                  </>
                </CollapseComponent>
              )}
            </Space>
          </Card>
        </Col>
      </Row>
      <Modal
        title={translate("manageOrder.invoiceDataModalTitle")}
        centered
        open={openPdfModal}
        onOk={() => setOpenPdfModal(false)}
        onCancel={() => setOpenPdfModal(false)}
        width={900}
        bodyStyle={{ height: 400 }}
        cancelText={translate("manageOrder.cancelBtnTitle")}
        mask
        maskClosable
        okButtonProps={{
          style: {
            display: "none",
          },
        }}
      >
        <>
          {invoiceLoader && (
            <Space
              align="center"
              className="d-flex justify-center align-center"
              style={{ height: "100%" }}
            >
              <Spin tip="Loading" size="large" />
            </Space>
          )}
        </>
        {!invoiceLoader && invoiceData && invoiceData?.length ? (
          <InvoiceDocument data={invoiceData} />
        ) : null}
      </Modal>
      <DuplicateModalComponent
        title={translate("manageOrder.confirmDuplicateTitle")}
        visible={isDuplicateOrder?.visible}
        onCancel={handleBack}
        dataTestSelector="popConfirm"
        zIndex={10}
        isMaskClosable={true}
        footer={null}
        className="duplicate-modal-popup"
      >
        {translate("manageOrder..duplicateModalMessage")}
        <div className="popup-action mt-24">
          <Space>
            <Button icon={<ArrowLeftOutlined />} onClick={handleBack} size={"middle"}>
              {translate("manageOrder.backBtn")}
            </Button>
            <Button type="primary" onClick={handleWithoutShipping} size={"middle"}>
              {translate("manageOrder.withoutShippingInformationBtn")}
            </Button>
            <Button type="primary" onClick={handleWithShipping} size={"middle"}>
              {translate("manageOrder.withShippingInformationBtn")}
            </Button>
          </Space>
        </div>
      </DuplicateModalComponent>
    </Space>
  );
};

export default ManageOrders;
