import { IOrder } from "interfaces/ClientInterface/IEditOrder";

export interface IOrderNoteUpdateParams {
  OrderId: string;
  ClassId: number;
  UserId: number;
  Note: string;
  OrderNoteId: string;
}
export interface IOrderNotesParams {
  MappingId: string;
  OrderId:string;
  TypeOfMapping: string;
  ClassId: number;
  UserId: number;
  Note: string;
  OrderNoteIds: string;
  IsDeleted: boolean;
  Message: string;
  ViewFilter: string;
}

export interface IOrderNotesForEditOrder {
  OrderNotes: IOrder;
  // eslint-disable-next-line no-unused-vars
  manageNotes?: (data: IOrderNotesParams) => void;
  getOrderDetails: () => void;
}
export interface filterTools {
  ToolType?: string;
}
export interface ILogsData {
  CreatedBy: string;
  NoteDetail: string;
  Created: string;
  Time: string;
  OrderId: string;
  OrderNoteId: string;
  Note: string;
  IsSystemDefine: boolean;
  CreatedByFullName: string;
  CreatedDate: string;
  MessageCode: number;
  PrefixNote: string;
}
export interface IExportParams {
  OrderId: string;
  FileType: string;
  ViewFilter: string;
}
export interface IOrderNoteFilters {
  OrderNotes: number;
  OrderStatusChanges: number;
  OwnerShipChanges: number;
  PriceChanges: number;
  FlagChanges: number;
  AllChanges: number;
  ViewAll: number;
}
