export interface IPayment {
  AddressId: string;
  AccountId: string;
  Address1: string;
  DisplayName: string;
  FirstName: string;
  LastName: string;
  CountryName: string;
  StateName: string;
  CityName: string;
  StateCode: string;
  PostalCode: string;
  PhoneNumber: string;
  IsDefaultBilling: boolean;
}

export interface IPaymentData {
  OrderDiscountId: string;
  OrderDiscountCode: string;
}

export interface IDiscountData {
  DiscountAmount: string;
  DiscountCode: string;
  DiscountType: string;
  OrderDiscountId: string;
}

export interface IDiscountItemValidate {
  VoucherNumber: boolean;
  CSRDiscount: boolean;
  CouponCode: boolean;
}

export interface IVoucherData {
  OrderDiscountId: string;
  ExpirationDate: string;
  VoucherMessage: string;
  VoucherNumber: string;
  VoucherAmount: string;
  IsVoucherValid: boolean;
  VoucherName: string;
  VoucherAmountApplied?: string;
}

export interface IUpdateDiscountData {
  VoucherId: string;
  CsrDiscountId: string;
  CouponCodeId: string;
}

export interface ICouponData {
  OrderDiscountId: string;
  Coupon: string;
  CouponValid: boolean;
  CouponApplied: boolean;
  CouponMessage: string;
  PromotionName: string;
}

export interface ICsrDiscountData {
  OrderDiscountId: string;
  CSRDiscountApplied: boolean;
  CSRDiscountMessage: string;
  CSRDiscountAmount: string;
}

export interface IPaymentError {
  BillToError: string;
  POError: string;
  VoucherNumber: string;
  CSRDiscount: string;
  CouponCode: string;
}
