export interface IProductDetails {
  ProductName: string;
  SKU: string;
  Quantity: string;
  Price: string;
  Total: string;
  totalProductQuantity: number;
  totalProductPrice: number;
  totalProductsCount: number;
}

export interface IOrderDetails {
  OrderStateName: string;
  OrderNumber: string;
  OrderTotal: string;
  CustomerName: string;
  OrderDate: string;
  Owner: string;
  CompanyName: string;
  OrderType?: string;
  LastUpdated: string;
  ShippingTo: string;
  ShippingMethod: string;
  FulfilledDate: string;
  ProductsList: IProductDetails[];
  OrderTypeName: string;
}

export interface IOrderDetailsForQuickView {
  OrderId: string;
  ClassId: number;
  ClassCode: string;
  ClassNumber: string;
  UserId: number;
  OrderDetail: string;
  OrderType: string;
  OrderOrigin: string;
  ProductionDate: string;
  OrderDate: string;
  OrderStateName: string;
  OrderTotal: string;
  Account: string;
  AccountName: string;
  FullName: string;
  CreatedByFullName: string;
  ModifiedByFullName: string;
  AssignToFullName: string;
  FinalizedDate: string;
  CreatedBy: number;
  CreatedDate: string;
  ModifiedBy: number;
  ModifiedDate: string;
  OrderTypeName: string;
}
export interface IQuickOrderProduct{
  Name: string;
  SKU: string;
  Id: string;
  CartQuantity: number;
  Quantity: number;
  ProductType: string;
  AddOnProductSkus: string;
  RetailPrice: string;
  GroupProductSKUs: string;
  GroupProductsQuantity: number;
  ConfigurableProductSKUs: string;
  AutoAddonSKUs: string;
  InventoryCode: string;
  IsActive: boolean;
  IsPersonalizable: boolean;
  UniqueId: number;
  InventoryMessage: string;
  QuantityOnHand:  string;
  ChildTrackInventory: string;
  VersionId?:number;
}