export interface IShippingTo {
  AddressId: string;
  AccountId: string;
  Address1: string;
  DisplayName: string;
  FirstName: string;
  LastName: string;
  CountryName: string;
  StateName: string;
  CityName: string;
  StateCode: string;
  PostalCode: string;
  PhoneNumber: string;
  IsDefaultShipping: boolean;
}

export interface IShippingMethod {
  PortalId: number;
  LocaleId: number;
  PublishedCatalogId: number;
  UserId: string;
  ShippingAddressModel: IShippingTo;
  ShippingId: string;
  ShippingName: string;
  ShippingRate: string;
  ShippingCost: string;
  Description: string;
  ShoppingCartItems: IShoppingCartModel[];
}

export interface IError {
  ShipToError: string;
  PhoneError: string;
  ShippingMethodError: string;
  TrackingNumberError: string;
  ShipDateError: string;
  ShippingOptionsError: string;
}

export interface IShoppingCartModel {
  Quantity: number;
  SKU: string;
  ConfigurableProductSKUs: string;
}
