import { Dispatch, SetStateAction } from "react";
import { IUserGroup } from "../APIInterface/IUserGroup";
import { IQuickViewOpen } from "./IQuickViewOrder";
import { IUsersListItem } from "../APIInterface/IAssignTo";
import { IOrder } from "interfaces/ClientInterface/IEditOrder";

export interface AssignedToProps {
  order: IOrder;
  groups: IUserGroup[];
  setOrder: Dispatch<SetStateAction<IOrder>>;
  setOrderUserGroup: Dispatch<SetStateAction<IUserGroup[]>>;
  notesChildRef:()=>void
  getOrderDetails:()=> void
}

export interface AssignToPopOverProps {
  icon: React.ReactNode;
  open: boolean;
  setOpen: Dispatch<SetStateAction<boolean>>;
  popOverTitle?: string;
  // eslint-disable-next-line no-unused-vars
  updateDataAfterSave: (data: IAssignToListResponse, userGroup: string) => void;
  isEditPermission: boolean;
  notesChildRef:()=>void
  getOrderDetails:()=>void
}

export interface IAssignUnAssignModal {
  open: boolean;
  // eslint-disable-next-line no-unused-vars
  setOpen: (isOpen: boolean) => void;
  modalStyle?: React.CSSProperties;
  onSaveCallback?: () => void;
  isMyTeam?: boolean;
  refetchList: () => void;
  assignToModalOpen?: IQuickViewOpen;
  myTeam: IUsersListItem[];
  selectedRowKeys?: React.Key[];
  setSelectedRowKeys: Dispatch<SetStateAction<React.Key[]>>;
}

export interface AssignToUserModalProps {
  open: boolean;
  // eslint-disable-next-line no-unused-vars
  setOpen: (flag: boolean) => void;
  children: React.ReactNode;
  calledFromTools?: boolean;
  refetchList: () => void;
  orderId?: string;
  myTeam: IUsersListItem[];
  selectedRowKeys?: React.Key[];
  setSelectedRowKeys: Dispatch<SetStateAction<React.Key[]>>;
  IsDelegateToMe?: boolean
}

export interface IAssignToListResponse {
  UserGroupsList: IUserGroupList;
  AssignToFullName: string;
}

export interface IUserGroupList {
  UserGroupsList: IUserGroup[];
}
