/* eslint-disable no-irregular-whitespace */
import { Dispatch, SetStateAction } from "react";

export interface IList {
  columns: IColumn[];
  data: IData[];
  pagination?: boolean;
  paginationPosition?:
    | "topLeft"
    | "topCenter"
    | "topRight"
    | "bottomLeft"
    | "bottomCenter"
    | "bottomRight";
  classSelector: string;
  isLoading?: boolean;
  rowSelection?: object;
  sortingColumn: { sortByColumnName: string; sortType: string };
  setSortingColumn: Dispatch<{ sortByColumnName: string; sortType: string }>;
  currentPage?: number;
  setCurrentPage?: Dispatch<SetStateAction<number>>;
}

export interface IColumn {
  title: string;
  dataIndex: string;
  key: string;
  //ToDo - need to add proper type checking
  // eslint-disable-next-line @typescript-eslint/no-explicit-any
  render?: any;
  // eslint-disable-next-line @typescript-eslint/no-explicit-any
  sorter?: any;
  hidden?: boolean;
}

export interface IData {
  ClassNumber: string;
  orderNumber: number;
  account: string;
  customer: string;
  status: string;
  created: string;
  time: string;
  total: string;
  OrderId: string;
  Age: string;
  CreatedDate: string;
  CPBackColor:string;
  CPTextColor:string;
  OmsOrderStateId:number
}

export interface TableDataProps {
  data: IData[];
}
