import { Dispatch, SetStateAction } from "react";

export interface IOrderFlagProps {
  orderFlags: IOrderFlag[];
  // eslint-disable-next-line no-unused-vars
  getUnAssociatedOrderFlag: (isOpen: boolean) => void;
    getOrderDetailsWithFlag: () => void;
    notesChildRef: () => void
    getOrderDetails:()=>void
}

export interface IOrderFlagsHeaderProps {
  openOrderFlagModal: () => void;
  orderFlags: IOrderFlag[];
}

export interface IOrderFlag {
  OrderFlagId: string;
  CPOrderFlagId: number;
  OrderType: string;
  MappingId: string;
  TypeOfMapping: string;
  CreatedBy: number;
  CreatedDate: string;
  ModifiedBy: number;
  ModifiedDate: string;
  FlagCode: string;
  DisplayOrder: number;
  NameChecked: string;
  NameUnchecked: string;
  IsChecked: boolean;
  IsCanOveride: boolean;
  NameOverridden: string;
  IsActiveOverridden: boolean;
  IsNAAttributeAvailable: boolean;

}

export interface IAddUpdateOrderFlag {
  OrderId?: string;
  OrderFlagId?: string;
  CPOrderFlagId?: string;
  OrderTypeCode?: string;
  UserId: string;
  IsChecked?: boolean;
  IsActiveOverridden?: boolean;
  IsCallForOverrideUserGroup?:boolean;
  ISNAflag? :boolean
}

export interface IOrderFlagCount {
  type: string;
  count: number;
}

export interface IUnAssociatedOrderFlag {
  unAssociatedOrderFlag: IUnAssociatedOrderFlagList[];
  selectedRowKeys: React.Key[];
  setSelectedRowKeys: Dispatch<SetStateAction<React.Key[]>>;
  setSearchInput: Dispatch<SetStateAction<string>>;
  searchInput: string;
}

export interface IUnAssociatedOrderFlagList {
  CPOrderFlagId: number;
  NameUnchecked: string;
}
