import { OrderStatusListProps } from "./IEditOrder";

export interface ISelectStatusDropdownProps {
  defaultValue?: string;
  // eslint-disable-next-line no-unused-vars, @typescript-eslint/no-explicit-any
  onChange?: (text: string, option: any) => void;
  disabled?: boolean;
  loading?: boolean;
  allowClear?: boolean;
  placeholder?: string;
  showSearch?: boolean;
  optionMenuPlacement?: "bottomLeft" | "bottomRight" | "topLeft" | "topRight";
  size?: "small" | "middle" | "large";
  className?: string;
  bordered?: boolean;
  dataTestSelector?: string;
  value?: string;
  orderStatusList: OrderStatusListProps[];
  selectedValueKey: string;
}

export interface ITagStyleProps {
  backgroundColor: string;
  border: string;
  color: string;
}

export interface IStatusTag {
  text: string;
  icon?: React.ReactNode | string;
  tagColor?: "success" | "processing" | "error" | "warning" | "default" | string;
  closable?: boolean;
  // eslint-disable-next-line no-unused-vars
  onCloseClick?: (id: string) => void;
  dataTestSelector?: string;
  closeIcon?: React.ReactNode;
  id?: string;
  tagStyle: ITagStyleProps;
}
