import { FILTERVALUE, ORDERTYPE, SAVEDVIEWFILTER, STORELIST, TABLECOLUMN } from "config/constant";
import { useAppDispatch } from "hooks/reduxHooks";
import React, { useEffect } from "react";

import { doLogout } from "store/slices/auth.slice";
import { removeLocalStorageData } from "utils/localStorage";

const Logout: React.FC = () => {
  const dispatch = useAppDispatch();

  useEffect(() => {
    dispatch(doLogout());
    const win: Window = window;
    win.location = "/auth/login";
    removeLocalStorageData(STORELIST);
    removeLocalStorageData(ORDERTYPE);
    removeLocalStorageData(TABLECOLUMN);
    removeLocalStorageData(FILTERVALUE);
    removeLocalStorageData(SAVEDVIEWFILTER);
  }, [dispatch]);

  return <></>;
};

export default Logout;
